/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;


#define ChecksumUint32 unsigned int

/*
	This is an implementation of Fletcher's checksum.
	http://en.wikipedia.org/w/index.php?title=Fletcher%27s_checksum

	Sample usage:

		JpChecksumFletcher32 Checksum;

		Checksum.AddUint32( (ChecksumUint32)value1 );
		Checksum.AddUint32( (ChecksumUint32)value2 );
		Checksum.AddUint32( (ChecksumUint32)value3 );
		
		ChecksumUint32 uiResult = Checksum.GetChecksum();


	mdomowicz 2013_09_06
*/
class JpChecksumFletcher32
{
	public:

		//-----------------------
		// public functions

		JpChecksumFletcher32();

		virtual ~JpChecksumFletcher32() {};

		void Init();

		void AddUint32( ChecksumUint32 ui );

		ChecksumUint32 GetChecksum() { return _uiChecksum; }

	private:

		//-----------------------
		// private variables

		ChecksumUint32 _uiSum1; 
		ChecksumUint32 _uiSum2;

		ChecksumUint32 _uiChecksum;
};




