/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>


#if DCG_IS_TARGET_ANDROID
	#include <sys/stat.h>
#endif

#if DCG_IS_TARGET_WIN32
	#include "direct.h"
#endif


#include "JpFileUtils.h"
#include "mmgrChooser.h"




/******************************************************************************
 FUNCTION:  JpFileUtils
******************************************************************************/
JpFileUtils::JpFileUtils()
{
}




/******************************************************************************
 FUNCTION:  ~JpFileUtils
******************************************************************************/
JpFileUtils::~JpFileUtils()
{
}




/******************************************************************************
 FUNCTION:  GetDirectoryListing
******************************************************************************/
bool JpFileUtils::GetDirectoryListing( JpStringList* pResults, char* pacDir )
{
/*
	dirent* dirp;

	DIR* dp = opendir( pacDir );
	
	ASSERTF( dp, ( "\nCould not open directory." ) );

	if ( dp ) 
	{
		dirp = readdir( dp );

		while ( dirp != NULL) 
		{
			JpString* pNewFileName = new JpString( dirp->d_name );
			pResults->AddLast( pNewFileName );
			dirp = readdir( dp );
		}

		closedir( dp );

		return true;
	}
	
	return false;
*/
	ASSERTF( 0, ( "\nNot yet implemented for cocos2d projects.  Requires dirent.h" ) );
	return false;
}



/******************************************************************************
 FUNCTION:  FileExists
******************************************************************************/
bool JpFileUtils::FileExists( char* pacPathAndFilename )
{
	FILE* pFile = fopen( pacPathAndFilename, "r" );
	bool bFileExists = ( pFile != NULL );
	
	if ( pFile )
		fclose( pFile );

	return bFileExists;	
}



/******************************************************************************
 FUNCTION:  DeleteFile
******************************************************************************/
bool JpFileUtils::DeleteFile( char* pacPathAndFilename )
{
	int iStatus = remove( pacPathAndFilename );
	bool bSuccess = ( iStatus == 0 );

	return bSuccess;
}



/******************************************************************************
 FUNCTION:  CreateDirectory
******************************************************************************/
void JpFileUtils::CreateDirectory( const char* pacPathAndFilename )
{
	#if DCG_IS_TARGET_WIN32
		_mkdir( pacPathAndFilename );
	#elif DCG_IS_TARGET_IOS
		CCApplication::sharedApplication().createDirectoryWithFullPath( pacPathAndFilename );
	#elif DCG_IS_TARGET_ANDROID
		CCFileUtils* pFileUtils = CCFileUtils::sharedFileUtils();

		char acFullPath[ 256 ] = "";
		sprintf( acFullPath, "%s%s", pFileUtils->getWriteablePath().c_str(), pacPathAndFilename );

		mkdir( acFullPath, 0777 );
	#else
		ASSERTF( 0, ( "\nJpFileUtils::CreateDirectory not implemented for this platform." ) );
	#endif
}