/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"
#include "JpHashTable.h"
#include "mmgrChooser.h"


/******************************************************************************
 FUNCTION:  JpHash
 PURPOSE:   creates a 32 bit hash value from any string.
 NOTES:		This hash function uses the FNV-1a algorithm, which is in the
			public domain.  See the following site for more info:
			http://www.isthe.com/chongo/tech/comp/fnv/index.html
******************************************************************************/
extern hash JpHash( const char* pacText )
{
	if ( pacText != 0 && *pacText != 0 )
	{
		hash uiHash = 0x811c9dc5;

		while( *pacText )
		{
			uiHash ^= ( hash )*pacText++ | 0x20;	// Suppress case.
			uiHash *= 0x01000193;
		}

		return uiHash;
	}

	return 0;
}



/******************************************************************************
 FUNCTION:  JpHashWithCase
 PURPOSE:   creates a 32 bit hash value from any string.
 NOTES:     This is a custom version from the standard JpHashTable function, in 
            that is does not suppress case.  In other words, to this function,
            'iVariableName' hash is different than 'ivariableNamE' hash
******************************************************************************/
extern hash JpHashWithCase( const char* pacText )
{
	if ( pacText != 0 && *pacText != 0 )
	{
		hash uiHash = 0x811c9dc5;

		while( *pacText )
		{
			uiHash ^= ( hash )*pacText++; // | 0x20;  // <-- The REM out would suppress case!
			uiHash *= 0x01000193;
		}

		return uiHash;
	}

	return 0;
}








