/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "JpUtils.h"
#include "NeCompass.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  NeCompass
******************************************************************************/
NeCompass::NeCompass()
{
}



/******************************************************************************
 FUNCTION:  ~NeCompass
******************************************************************************/
NeCompass::~NeCompass()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void NeCompass::Init()
{
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void NeCompass::Deinit()
{
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void NeCompass::Update( float dt )
{
}



/******************************************************************************
 FUNCTION:  GetFacingFromDirection
******************************************************************************/
NeCompass::FACING NeCompass::GetFacingFromDirection
( 
	const JpVector2f& vReferenceUp, 
	const JpVector2f vDir 
)
{
	float f = GetSignedAngleBetween2d( vReferenceUp, vDir ) * RAD2DEG;

	if ( f >= -22.5f && f < 22.5f  )
		return FACING_NORTH;
	else if ( f >= 22.5f && f < 67.5f )
		return FACING_NORTH_WEST;
	else if ( f >= 67.5f && f < 112.5 )
		return FACING_WEST;
	else if ( f >= 112.5f && f < 157.5 )
		return FACING_SOUTH_WEST;
	else if ( f >= 157.5f && f < 180.0f )
		return FACING_SOUTH;

	else if ( f >= -67.5f && f < -22.5f )
		return FACING_NORTH_EAST;
	else if ( f >= -112.5f && f < -67.5f )
		return FACING_EAST;
	else if ( f >= -157.5f && f < -112.5f )
		return FACING_SOUTH_EAST;
	else if ( f >= -180.0f && f < -157.5f )
		return FACING_SOUTH;

	ASSERTF( 0, ( "\nFlow should never reach here.  Impossible!" ) );
	return FACING_LAST;
}



/******************************************************************************
 FUNCTION:  GetRandomCardinalFacing
******************************************************************************/
NeCompass::FACING NeCompass::GetRandomCardinalFacing( JpRandom* pRng )
{
	int iDice = 0;

	if ( !pRng )
		iDice = JpRandom::G.GetInt() % 4;
	else
		iDice = pRng->GetInt() % 4;

	switch ( iDice )
	{
		case 0: return FACING_NORTH;
		case 1: return FACING_EAST;
		case 2: return FACING_SOUTH;
		case 3: return FACING_WEST;
	}

	ASSERTF( 0, ( "\nCompass facing not chosen." ) );
	return FACING_LAST;
}



/******************************************************************************
 FUNCTION:  GetNextCardinalFacingClockwise
******************************************************************************/
NeCompass::FACING NeCompass::GetNextCardinalFacingClockwise
( 
	FACING eCurrentDirection 
)
{
	switch ( eCurrentDirection )
	{
		case FACING_NORTH: return FACING_EAST;
		case FACING_EAST:  return FACING_SOUTH;
		case FACING_SOUTH: return FACING_WEST;
		case FACING_WEST:  return FACING_NORTH;
	}

	return FACING_LAST;
}



/******************************************************************************
 FUNCTION:  GetNextCardinalFacingCounterClockwise
******************************************************************************/
NeCompass::FACING NeCompass::GetNextCardinalFacingCounterClockwise
( 
	FACING eCurrentDirection 
)
{
	switch ( eCurrentDirection )
	{
		case FACING_NORTH: return FACING_WEST;
		case FACING_WEST:  return FACING_SOUTH;
		case FACING_SOUTH: return FACING_EAST;
		case FACING_EAST:  return FACING_NORTH;
	}

	return FACING_LAST;
}
