/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpRandom.h"

USING_NS_CC;


class NeCompass
{
	public:

		//-----------------------
		// public enums
		enum FACING
		{
			FACING_NORTH,
			FACING_NORTH_EAST,
			FACING_EAST,
			FACING_SOUTH_EAST,
			FACING_SOUTH,
			FACING_SOUTH_WEST,
			FACING_WEST,
			FACING_NORTH_WEST,
			FACING_LAST,
		};


		//-----------------------
		// public functions

		NeCompass();

		virtual ~NeCompass();

		void Init();

		void Deinit();

		void Update( float dt );

		static FACING GetFacingFromDirection( const JpVector2f& vReferenceUp, const JpVector2f vDir );

		static FACING GetRandomCardinalFacing( JpRandom* pRng );
		static FACING GetNextCardinalFacingClockwise( FACING eCurrentFacing );
		static FACING GetNextCardinalFacingCounterClockwise( FACING eCurrentFacing );

	private:

		//-----------------------
		// private variables
};




