/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;


/*
	This module is a wrapper for basic file reading/writing operations, such as
	fopen/fclose/getc etc.

	The reason this is needed is because basic file operations do not work on Android.
	
	mdomowicz 2012_11_21
*/


class NeFile
{
	public:

		//-----------------------
		// public functions

		NeFile();

		virtual ~NeFile();

		bool OpenFile( const char* pacPathAndFilename, char* pacModeFlags );
		void CloseFile();

		void Seek( long int lOffset, int iOriginFlag );
		char GetChar();

	private:

		//-----------------------
		// private variables

		// Used in most cases.
		FILE* _pFile;

		// Used when the FILE* pointer can't be used (eg, on Android)
		unsigned char* _pacFileData;
		unsigned long _ulFileDataIndex;
		unsigned long _ulFileSize;

};




