/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "NeRandomPoolPicker.h"

#include "mmgrChooser.h"


USING_NS_CC;





/******************************************************************************
 FUNCTION:  AddValueInt
******************************************************************************/
void NeRandomPoolPicker::AddValueInt( int iValue, int iCount )
{
	if ( iCount > 0 )
	{
		Entry* pNewEntry = new Entry;
		pNewEntry->SetIntValue( iValue );
		pNewEntry->SetRange( _iCurrentMax, _iCurrentMax + iCount );

		_iCurrentMax += iCount;

		_EntryList.AddLast( pNewEntry );
	}
}



/******************************************************************************
 FUNCTION:  SelectValueFromPool
******************************************************************************/
int NeRandomPoolPicker::SelectValueFromPool( JpRandom* pRng )
{
	ASSERTF( _iCurrentMax != 0, ( "\nThe pool does not have a valid value count." ) );

	if ( _iCurrentMax > 0 )
	{
		int iDice = 0;

		if ( !pRng )
			iDice = JpRandom::G.GetInt() % _iCurrentMax;
		else
			iDice = pRng->GetInt() % _iCurrentMax;

		JpList< Entry >::Iterator Iter( &_EntryList );
		while ( Iter.Next() )
		{
			Entry* pEntry = Iter.GetNodeData();
			if ( pEntry->IsInRange( iDice ) )
				return pEntry->GetIntValue();
		}
	}

	ASSERTF( 0, ( "\nShould never get here.  Something is wrong." ) );
	return 0;
}



