/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"

#include "fmod.hpp"


class NeSoundEffect
{
	public:

		//-----------------------
		// public functions

		NeSoundEffect();

		virtual ~NeSoundEffect() {};

		void Play();
		void Stop();
		void Pause( bool bPause );
		bool IsPaused();
		
		FMOD::Sound* GetSound() { return _pSound; }
		void SetSound( FMOD::Sound* p ) { _pSound = p; }

		FMOD::Channel* GetChannel() { return _pChannel; }

		void SetVolume( float fNormalizedVolume );

		void SetLoopCount( int i ) { _iLoopCount = i; }

		static void SetFmodSoundSystem( FMOD::System* p ) { _pFmodSystem = p; }

		static FMOD_RESULT F_CALLBACK ChannelCallback
		(
			FMOD_CHANNEL *channel, 
			FMOD_CHANNEL_CALLBACKTYPE type, 
			void *commanddata1, 
			void *commanddata2
		);


	private:

		//-----------------------
		// private variables

		static FMOD::System* _pFmodSystem;

		FMOD::Sound* _pSound;
		FMOD::Channel* _pChannel;
		
		int _iLoopCount;
};




