/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

/*
	GIGANTIC CAVEAT!  I wrote this in 2000, or maybe even earlier.  I was a
	much worse programmer then than I am now.  If something seems/looks crap
	or broken...it may very well be either or both.

	However, it's worth noting that this code was used in almost every 
	personal project, including Anthem, and has seemed to be ok enough, so
	if not all that pretty or efficient, at least it's relatively battle tested.
	
	mdomowicz 2011_08_28
*/


#include "stdafx.h"

#include <stdio.h>

#include "cocos2d.h"


USING_NS_CC;


// These defines are used in case I want to move this file over
// to an engine that itself #defines its own types.
#define _BOOL_    bool
#define _CHAR_    char
#define _INT_     int
#define _UINT16_  unsigned short
#define _UINT32_  unsigned long
#define _BYTE_    unsigned char

// Behavior may need to be different depending on if this
// code is being used in a console app or not.
#define IS_TGA_CONSOLE_APP     0

// do we want lots of file info outputed to console?
#define TGA_VERBOSE            1 && IS_TGA_CONSOLE_APP



class TGA_DEVELOPER_DATA
{
	public:
		//-----------------------
		// function declarations
		//-----------------------
		TGA_DEVELOPER_DATA();

		~TGA_DEVELOPER_DATA();

		//-----------------------
		// variable declarations
		//-----------------------
		_UINT16_      umTag;
		_UINT32_      umOffset;
		_UINT32_      umSize;
		_BYTE_*       umData;


	private:
};





class NeTgaIo
{
	public:
		//-----------------------
		// function declarations
		//-----------------------
		NeTgaIo() { Init(); }

		~NeTgaIo();

		void Init();

		_BOOL_ Read( _CHAR_ cFileName[] );

		_BOOL_ Read
		( 
			_BYTE_** pabImageData, 
			int* piWidth, 
			int* piHeight, 
			int* piBitsPerPixel, 
			_CHAR_ acFileName[] 
		);


	private:
		//-----------------------
		// variable declarations
		//-----------------------
		_CHAR_    cmFileName[256];
		_BOOL_    bmIsNewTGA;

		_UINT32_  umExtensionAreaOffset;
		_UINT32_  umDeveloperDirOffset;
		_CHAR_    acmSignature[18];	/* signature string	*/
		_BYTE_    umIDLength;
		_BYTE_    bmColorMapType;
		_BYTE_    bmImageType;

		_UINT16_  umColorMapSpecFirstEntryIndex;
		_UINT16_  umColorMapSpecMapLength;
		_BYTE_    bmColorMapSpecMapEntrySize;

		_UINT16_  umImageSpecXOrigin;
		_UINT16_  umImageSpecYOrigin;
		_UINT16_  umImageSpecImageWidth;
		_UINT16_  umImageSpecImageHeight;
		_BYTE_    bmImageSpecPixelDepth;
		_BYTE_    bmImageSpecImageDescriptor;

		_CHAR_    acmImageID[256];
		_BYTE_*   pabmColorMapData;
		_BYTE_*   pabmImageData;

		_UINT16_  umDeveloperDirNumTags; 
		TGA_DEVELOPER_DATA* pamDeveloperDirData;

		_UINT16_   umExtensionSize;
		_CHAR_     acmExtensionAuthorName[41];
		_CHAR_     acmExtensionAuthorCommentsLine1[81];
		_CHAR_     acmExtensionAuthorCommentsLine2[81];
		_CHAR_     acmExtensionAuthorCommentsLine3[81];
		_CHAR_     acmExtensionAuthorCommentsLine4[81];
		_UINT16_   umExtensionTimeStampMonth;
		_UINT16_   umExtensionTimeStampDay;
		_UINT16_   umExtensionTimeStampYear;
		_UINT16_   umExtensionTimeStampHour;
		_UINT16_   umExtensionTimeStampMinute;
		_UINT16_   umExtensionTimeStampSecond;
		_CHAR_     acmExtensionJobName[41];
		_UINT16_   umExtensionJobTimeHours;
		_UINT16_   umExtensionJobTimeMinutes;
		_UINT16_   umExtensionJobTimeSeconds;
		_CHAR_     acmExtensionSoftwareID[41];
		_UINT16_   umExtensionSoftwareVerNumber;
		_CHAR_     cmExtensionSoftwareVerLetter;
		_UINT32_   umExtensionTransparentColor;
		_UINT16_   umExtensionAspectRatioNumerator;
		_UINT16_   umExtensionAspectRatioDenominator;
		_UINT16_   umExtensionGammaRatioNumerator;
		_UINT16_   umExtensionGammaRatioDenominator;
		_UINT32_   umExtensionColorCorrectionOffset;
		_UINT32_   umExtensionPostageStampOffset;
		_UINT32_   umExtensionScanLineOffset;
		_BYTE_     bmExtensionAttributesType;

		//-----------------------
		// function declarations
		//-----------------------

		_BYTE_    ReadByte( FILE* pFile );
		_UINT32_  ReadLong( FILE* pFile );
		_UINT16_  ReadShort( FILE* pFile );

		_BOOL_    ReadFileFooter( FILE* pFile );
		_BOOL_    ReadFileHeader( FILE* pFile );
		_BOOL_    ReadImageID( FILE* pFile );
		_BOOL_    ReadColorMapData( FILE* pFile );
		_BOOL_    ReadImageData( FILE* pFile );
		_BOOL_    ReadDeveloperArea( FILE* pFile );
		_BOOL_    ReadExtensionArea( FILE* pFile );
};


