/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;


class NeUtils
{
	public:

		//-----------------------
		// public functions

		NeUtils();

		virtual ~NeUtils();

		void Init();

		void Deinit();

		void Update( float dt );


		// This function is mostly a copy of the getFileData in \platform\win32\CCFileUtils.
		// It is ported here so the memory allocations can be tracked by mmgr.h
		// You should always use this version of GetFileData, and never use
		// the one in CCFileUtils.
		// mdomowicz 2013_10_31
		/**
		@brief Get resource file data
		@param[in]  pszFileName The resource file name which contain the path
		@param[in]  pszMode The read mode of the file
		@param[out] pSize If get the file data succeed the it will be the data size,or it will be 0
		@return if success,the pointer of data will be returned,or NULL is returned
		@warning If you get the file data succeed,you must delete[] it after used.   <-------------!!!! WARNING !!!!
		*/
		static unsigned char* GetFileData( const char* pszFileName, const char* pszMode, unsigned long* pSize );

		static bool DoesFileExist( const char* pszFileName );

		// This is a printf style logging function that also works on Android
		static void DcgLog( const char* pFormat, ... );

	private:

		//-----------------------
		// private variables
};




