/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoActorManager.h"
#include "SoGameBit.h"

USING_NS_CC;


class SoActorSorter
{
	public:
		//-----------------------
		// public functions
		SoActorSorter() { Init(); }
		virtual ~SoActorSorter() { Deinit(); }

		static void Init();

		static void Deinit();

		static void Update( float dt );

		static void ClearAllLists();

		static int GetNumExistingActorsByType( SoActorTypes::TYPE eType );
	
		static SoActorList* GetHudMapActorList() { return &_HudMapActorList; }
		static SoActorList* GetMovableActorsList() { return &_MovableActorsList; }

		static SoActorSorter* GetInstance() { return _pInstance; }
		static void CreateInstance();
		static void DeleteInstance();

	private:

	
		//-----------------------
		// private variables
		static SoActorSorter* _pInstance;

		static int _aiExistingActorTallies[ SoActorTypes::TYPE_LAST ];

		static SoActorList _HudMapActorList;
		static SoActorList _MovableActorsList;

		//-----------------------
		// private functions
		static void IncrementExistingActorsByType( SoActorTypes::TYPE eType );
		static void ClearActorCounts();

};





