/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include <stdio.h>

#include "JpHashTable.h"
#include "JpUtils.h"
#include "SoActorTypes.h"
#include "mmgrChooser.h"





/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoActorTypes::Init()
{
}




/******************************************************************************
 FUNCTION:  GetTypeFromString
******************************************************************************/
SoActorTypes::TYPE SoActorTypes::GetTypeFromString( const char* pacString )
{
	unsigned int uiStringHash = JpHash( pacString );

	switch ( uiStringHash )
	{
		case 0xd858c35f /* "TYPE_ACTOR" */: return TYPE_ACTOR;
		case 0xd4e275a2 /* "TYPE_ACTOR_VISIBLE" */: return TYPE_ACTOR_VISIBLE;
		case 0xe25b2a6e /* "TYPE_ACTOR_VISIBLE_BOARD_SPOT" */: return TYPE_ACTOR_VISIBLE_BOARD_SPOT;
		case 0xb59c7ab9 /* "TYPE_ACTOR_VISIBLE_COORDINATE" */: return TYPE_ACTOR_VISIBLE_COORDINATE;
		case 0xfd4c270f /* "TYPE_ACTOR_VISIBLE_HOTEL" */: return TYPE_ACTOR_VISIBLE_HOTEL;
		case 0xae48999d /* "TYPE_ACTOR_VISIBLE_MONEY" */: return TYPE_ACTOR_VISIBLE_MONEY;
		case 0x981e5646 /* "TYPE_ACTOR_VISIBLE_PLAYER" */: return TYPE_ACTOR_VISIBLE_PLAYER;
		case 0x93430db3 /* "TYPE_ACTOR_VISIBLE_TILE" */: return TYPE_ACTOR_VISIBLE_TILE;

		default: ASSERTF( 0, ( "\nString could not be converted to Actor Type." ) );
	}

	return TYPE_LAST;
}




/******************************************************************************
 FUNCTION:  GetStringFromType
******************************************************************************/
const char* SoActorTypes::GetStringFromType( TYPE eType )
{
	switch ( eType )
	{
		case TYPE_ACTOR: return "TYPE_ACTOR";
		case TYPE_ACTOR_VISIBLE: return "TYPE_ACTOR_VISIBLE";
		case TYPE_ACTOR_VISIBLE_BOARD_SPOT: return "TYPE_ACTOR_VISIBLE_BOARD_SPOT";
		case TYPE_ACTOR_VISIBLE_COORDINATE: return "TYPE_ACTOR_VISIBLE_COORDINATE";
		case TYPE_ACTOR_VISIBLE_HOTEL: return "TYPE_ACTOR_VISIBLE_HOTEL";
		case TYPE_ACTOR_VISIBLE_MONEY: return "TYPE_ACTOR_VISIBLE_MONEY";
		case TYPE_ACTOR_VISIBLE_PLAYER: return "TYPE_ACTOR_VISIBLE_PLAYER";
		case TYPE_ACTOR_VISIBLE_TILE: return "TYPE_ACTOR_VISIBLE_TILE";
		default: ASSERTF( 0, ( "\nActor Type not found." ) );
	}

	return NULL;
}

