/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoActorVisible.h"
#include "SoUtils.h"


#define VISIBLE_BOARD_SPOT_SHOW_COORDINATE_LABELS false


class SoGameBitPlayer;


class SoActorVisibleBoardSpot : public SoActorVisible
{
	public:

		//-----------------------
		// public functions
		SoActorVisibleBoardSpot();
		virtual ~SoActorVisibleBoardSpot() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void SynchronizeAfterLoad();

		virtual void Update( float dt );

		virtual SoActorTypes::TYPE GetType() { return SoActorTypes::TYPE_ACTOR_VISIBLE_BOARD_SPOT; }

		virtual SoActorVisibleBoardSpot* GetAsVisibleBoardSpot() { return this; }

		virtual void SetScale( const JpVector2f& vScale );


		SoGameBitTile* GetGameBitTile() { return _pGameBitTile; }
		void SetGameBitTile( SoGameBitTile* p );


		int GetRenderZOrder() { return _iRenderZOrder; }
		void SetRenderZOrder( int i ) { _iRenderZOrder = i; }
		

	private:

		//-----------------------
		// private variables
		SoGameBitTile* _pGameBitTile;

		SoLabelBmFont* _pLabel;

		float _fTimeHighlighted;

		int _iRenderZOrder;


		//-----------------------
		// private functions
		void CreateBoardSpotSprite();
		void CreateLabel();

		JpVector2f GetTargetPosition();

		bool ShouldHighlightForHumanPlayer();
		bool ShouldHighlightForDebugPlayer();
};


