/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoActorVisible.h"
#include "SoUtils.h"



class SoGameBitPlayer;


class SoActorVisibleCoordinate : public SoActorVisible
{
	public:

		//-----------------------
		// public functions
		SoActorVisibleCoordinate();
		virtual ~SoActorVisibleCoordinate() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual SoActorTypes::TYPE GetType() { return SoActorTypes::TYPE_ACTOR_VISIBLE_COORDINATE; }

		virtual void SetScale( const JpVector2f& vScale );

		void SetLabelText( const std::string& s );

	private:

		//-----------------------
		// private variables
		SoLabelBmFont* _pLabel;

		//-----------------------
		// private functions
		void CreateLabel();

		JpVector2f GetTargetPosition();
};


