/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoActorVisible.h"
#include "SoUtils.h"


class SoGameBitPlayer;


class SoActorVisibleHotel : public SoActorVisible
{
	public:

		//-----------------------
		// public functions
		SoActorVisibleHotel();
		virtual ~SoActorVisibleHotel() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void SynchronizeAfterLoad();

		virtual void Update( float dt );

		virtual SoActorTypes::TYPE GetType() { return SoActorTypes::TYPE_ACTOR_VISIBLE_HOTEL; }

		virtual SoActorVisibleHotel* GetAsVisibleHotel() { return this; }

		virtual void SetScale( const JpVector2f& vScale );


		SoGameBitHotel* GetGameBitHotel() { return _pGameBitHotel; }
		void SetGameBitHotel( SoGameBitHotel* p ) { _pGameBitHotel = p; }

		static ccColor3B GetHotelColorById( int iHotelId );

		static std::string GetHoteNameById( int iHotelId );

		static float GetSpriteHeightToWidthRatio( int iHotelId );

	private:

		//-----------------------
		// private variables
		SoGameBitHotel* _pGameBitHotel;

		int _iRenderOrderState;

		static float _afSpriteHeightToWidthRatios[ GAMERULES_NUM_HOTELS ];


		//-----------------------
		// private functions
		void CreateHotelSprite();

		void UpdateRenderOrder( float dt );

		void SetRenderZOrder( int iRenderZOrder );

		JpVector2f GetTargetPosition();

		static void SetSpriteHeightToWidthRatio( int iHotelId, SoSprite* pSprite );
};


