/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoActorVisible.h"
#include "SoUtils.h"


class SoGameBitPlayer;

class SoActorVisiblePlayer : public SoActorVisible
{
	public:

		//-----------------------
		// public enums
		enum STATE
		{
			STATE_WAIT,
			STATE_WON,
			STATE_LAST
		};


		//-----------------------
		// public functions
		SoActorVisiblePlayer();
		virtual ~SoActorVisiblePlayer() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual SoActorTypes::TYPE GetType() { return SoActorTypes::TYPE_ACTOR_VISIBLE_PLAYER; }

		virtual SoActorVisiblePlayer* GetAsVisiblePlayer() { return this; }

		static JpVector2f GetBoardWorldPositionForPlayer( int iPlayerNumber );

		SoGameBitPlayer* GetGameBitPlayer();
		void SetGameBitPlayer( SoGameBitPlayer* p );

		static std::string GetPlayerNameByPlayerNumber( int iPlayerNumber );

		static ccColor3B GetColorByPlayerNumber( int iPlayerNumber );

	private:

		//-----------------------
		// private variables
		SoGameBitPlayer* _pGameBitPlayer;
		STATE _eState;

		int _iPreviousMoney;
		int _iPreviousScore;

		int _iLastPlayer;

		//-----------------------
		// private functions
		void PrintToHudLog( int iPlayerNumber, const std::string& s );
		void PrintToHudLogF( int iPlayerNumber, const char* pFormat, ... );

		JpVector2f GetBaseKickerPosition();

		void ShowPlayerWinNotice();
		void ShowPlayerScoreNotice();
		void ShowPlayerTurnNotice();
};


