/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGameBitCard.h"

USING_NS_CC;


class SoCardDeck
{
	public:

		//-----------------------
		// public functions

		SoCardDeck();

		virtual ~SoCardDeck();

		void Init();

		void Deinit();

		void Update( float dt );


		virtual void NewGameShuffle( hash hRngSeed );

		void AddCard( SoGameBitCard* pCard );

		SoGameBitCardList* GetAllCards() { return &_AllCards; }
		SoGameBitCardList* GetDrawPile() { return &_DrawPile; }
		SoGameBitCardList* GetDiscardPile() { return &_DiscardPile; }


	protected:

		//-----------------------
		// protected variables


		SoGameBitCardList _AllCards;
		SoGameBitCardList _DrawPile;
		SoGameBitCardList _DiscardPile;


		//-----------------------
		// protected functions
		void ShuffleCardList( SoGameBitCardList* pList, JpRandom* pRng );

		void PrintToConsole( const std::string& s );
		void CPrintF( const char* pFormat, ... );
};




