/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoClipNode.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoClipNode
******************************************************************************/
SoClipNode::SoClipNode() :
_bEnableClipping( false ),
_fLeftX( 0.0f ),
_fBottomY( 0.0f ),
_fWidth( 0.0f ),
_fHeight( 0.0f )
{
}



/******************************************************************************
 FUNCTION:  ~SoClipNode
******************************************************************************/
SoClipNode::~SoClipNode()
{
}



/******************************************************************************
 FUNCTION:  SetClippingRegion
******************************************************************************/
void SoClipNode::SetClippingRegion( float fLeftX, float fBottomY, float fWidth, float fHeight )
{
	_fLeftX = fLeftX;
	_fBottomY = fBottomY;
	_fWidth = fWidth;
	_fHeight = fHeight;	
}



/******************************************************************************
 FUNCTION:  visit
******************************************************************************/
void SoClipNode::visit() 
{
	if ( _bEnableClipping )
	{
		glEnable(GL_SCISSOR_TEST);
		
		CCEGLView::sharedOpenGLView().setScissorInPoints( _fLeftX, _fBottomY, _fWidth, _fHeight );
	}
	
	CCNode::visit();
		
	if ( _bEnableClipping )
		glDisable(GL_SCISSOR_TEST);
}
	


