/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;


class SoGameState;
class SoGameMessage;

class SoDebug
{
	public:

		//-----------------------
		// public enums
		enum DEBUG_MESSAGE_ID
		{
			DEBUG_MESSAGE_ID_GIVE_PLAYER_MONEY,
			DEBUG_MESSAGE_ID_GIVE_PLAYER_ALL_TILES,
			DEBUG_MESSAGE_ID_GIVE_PLAYER_TILE,
			DEBUG_MESSAGE_ID_LAST
		};


		//-----------------------
		// public functions

		SoDebug();

		virtual ~SoDebug();

		void Init();

		void Deinit();

		void Update( float dt );


		static void HandleDebugMessage( SoGameState* pGame, SoGameMessage* pMessage );

		static int GetPlayerWithDebugHighlightEnabled() { return _iPlayerWithDebugHightlightEnabled; }
		static void SetPlayerWithDebugHighlightEnabled( int i ) { _iPlayerWithDebugHightlightEnabled = i; }

		static void CreatePrettyGameMessageString( std::string* psResult, SoGameMessage* pMessage );

	private:

		//-----------------------
		// private variables

		static int _iPlayerWithDebugHightlightEnabled;
};




