/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpList.h"

USING_NS_CC;

class SoSprite;

#define SoPointList JpList< CCPoint >

class SoDrawCustom : public CCNode
{
	public:

		//-----------------------
		// public functions
		SoDrawCustom();
		virtual ~SoDrawCustom();

		virtual void Setup( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		bool IsActive() { return _bIsActive; }
		void SetIsActive( bool b ) { _bIsActive = b; }

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }


		void SetBlipLineWindowWidth( float fWidthInPixels ) { _fBlipLineWindowWidth = fWidthInPixels; }
		void AddPointToBlipLine( float fY );
		void ClearBlipLine() { _BlipLine.DeleteAll(); }
		void SetBlipLineColor( const ccColor3B& Color ) { _BlipLineColor = Color; }

		void SetSampleLineWindowWidth( float fWidthInPixels ) { _fSampleLineWindowWidth = fWidthInPixels; }
		void AddPointToSampleLine( float fY );
		void ClearSampleLine() { _SampleLine.DeleteAll(); }
		void SetSampleLineColor( const ccColor3B& Color ) { _SampleLineColor = Color; }


		// CCNode overrides
		virtual void draw(void);
		virtual bool init() { return true; }
		static SoDrawCustom* create();


	protected:

		//-----------------------
		// protected variables
		CCNode* _pParentNode;

		bool _bIsActive;

		SoPointList _BlipLine;
		float _fBlipLineWindowWidth;
		ccColor3B _BlipLineColor;

		SoPointList _SampleLine;
		float _fSampleLineWindowWidth;
		ccColor3B _SampleLineColor;


		//-----------------------
		// protected functions
		void DrawBlipLine();
		void DrawSampleLine();

};




