/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpList.h"

USING_NS_CC;

// This is not a setting - do not change.
// This is only for code readability
#define DCG_CLOSE_POLYGON true

#define SoDebugShapeList  JpList< SoDrawDebug::Shape >


class SoDrawDebug : public CCNode
{
	public:

		//-----------------------
		// public classes
		class Shape
		{
			public: 
				Shape() {};
				virtual ~Shape() {};
				virtual void draw() {};
			private:
		};

		class ShapeBox : public Shape
		{
			public: 
				ShapeBox();
				virtual ~ShapeBox() {};
				virtual void draw();

				void SetPosition( float fX, float fY ) { _fX = fX; _fY = fY; }
				void SetWidth( float f ) { _fWidth = f; }
				void SetHeight( float f ) { _fHeight = f; }

			private:

				float _fWidth;
				float _fHeight;
				float _fX;
				float _fY;
		};


		//-----------------------
		// public functions
		SoDrawDebug();
		virtual ~SoDrawDebug();

		virtual void Setup( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		bool IsActive() { return _bIsActive; }
		void SetIsActive( bool b ) { _bIsActive = b; }

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }


		void AddBox( float fX, float fY, float fWidth, float fHeight );


		// CCNode overrides
		virtual void draw(void);
		virtual bool init() { return true; }
		static SoDrawDebug* create();


	protected:

		//-----------------------
		// protected variables
		CCNode* _pParentNode;

		bool _bIsActive;

		SoDebugShapeList _ShapeList;

		//-----------------------
		// protected functions

};




