/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpHashTable.h"
#include "JpList.h"

USING_NS_CC;


class SoLabelBmFont;


class SoFontDefs
{
	public:

		//-----------------------
		// public functions
		SoFontDefs() {};
		virtual ~SoFontDefs() {};

		static const char* GetTestLarge();
		static const char* GetTestMedium();
		static const char* GetTestSmall();
		static const char* GetNameTextEntry();
		static const char* GetHudLog();
		static const char* GetWinLog();
		static const char* GetKicker();
		static const char* GetHudGold();
		static const char* GetHudPlayerGuide();
		static const char* GetHudPlayerGuideScore();
		static const char* GetHudTurns();

		static const char* GetGuiDefault();
		static const char* GetGuiDefaultMedium();
		static const char* GetGuiDefaultLarge();
		static const char* GetVisibleDamageMultiplier();

		static const char* GetCredits();
		static const char* GetCreditsMedium();
		static const char* GetCreditsLarge();

		static const char* GetBoardSpot();
		static const char* GetHotelStats();

		static const char* GetWatermark();

		static void PreloadFont( const char* pFontName );
		static void DestroyPreloadedFonts();

		static bool HighScoreFontsAreLoaded();

	private:

		static JpList< SoLabelBmFont > _PreLoadedFontsList;

		//-----------------------
		// private functions
		static SoLabelBmFont* PerformActualPreload( std::string sFontName );
		static bool FontHasBeenPreloaded( const char* pFontName );
};




