/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoFsmState.h"
#include "SoWatermark.h"


class SoFsmBootLayer;
class SoSprite;

class SoFsmStateBoot : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateBoot();

		virtual ~SoFsmStateBoot();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmBootLayer* _pLayer;
};






class SoFsmBootLayer : public cocos2d::CCLayerColor
{
	public:
		enum eSubState
		{
			eSubState_Screen1,
			eSubState_Screen2,
			eSubState_Done,
			eSubState_Last
		};

		SoFsmBootLayer();
		virtual ~SoFsmBootLayer();

		virtual bool init();
		virtual void update( float dt );

		LAYER_NODE_FUNC(SoFsmBootLayer);

		bool IsDone();
		bool IsTouched() { return _bTouched; }


		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);


		static SoFsmBootLayer* create();

	private:
		bool _bTouched;
		float _fTimer;

		eSubState _eState;

		SoSprite* _pSplashSprite1;
		SoSprite* _pSplashSprite2;

		SoWatermarkPreRelease _WatermarkPreRelease;
};