/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoFsmState.h"
#include "SoGuiManager.h"

class SoFsmCreditsLayer;
class SoSprite;

class SoFsmStateCredits : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateCredits();

		virtual ~SoFsmStateCredits();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmCreditsLayer* _pLayer;
};






class SoFsmCreditsLayer : public cocos2d::CCLayerColor
{
	public:
		enum eSubState
		{
			eSubState_Screen1,
			eSubState_Done,
			eSubState_Last
		};

		SoFsmCreditsLayer();
		virtual ~SoFsmCreditsLayer();

		virtual bool init();
		virtual void update( float dt );

		LAYER_NODE_FUNC(SoFsmCreditsLayer);

		bool IsDone();
		bool IsTouched() { return _bTouched; }


		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);


		static SoFsmCreditsLayer* create();

	private:
		bool _bTouched;
		float _fTimer;

		eSubState _eState;

		SoSprite* _pSplashSprite1;

		guid _gGuiScrollText;
		SoGuiManager _GuiManager;
};

















