/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiManager.h"
#include "SoFsmState.h"
#include "SoScreenFader.h"
#include "SoUiButton.h"
#include "SoWatermark.h"


class SoGuiAnimWinNewOrLoadGame;
class SoGuiAnimWinSetupGame;
class SoGuiAnimWinSetupPlayers;
class SoFsmSetupOfflineGameLayer;
class SoSpriteAnim;


class SoFsmStateSetupOfflineGame : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateSetupOfflineGame();

		virtual ~SoFsmStateSetupOfflineGame();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmSetupOfflineGameLayer* _pLayer;
};






class SoFsmSetupOfflineGameLayer : public cocos2d::CCLayerColor
{
	public:

		//-----------------------
		// public functions

		SoFsmSetupOfflineGameLayer();
		virtual ~SoFsmSetupOfflineGameLayer();

		virtual bool init();
		void Deinit();

		virtual void update( float dt );
		virtual void draw();

		LAYER_NODE_FUNC(SoFsmSetupOfflineGameLayer);


		bool IsReadyToExitState() { return _bReadyToExitState; }
		bool IsStartGameSelected() { return _bGameSetupStartSelected; }
		bool IsLoadGameSelected() { return _bLoadGameSelected; }
		bool IsPlayerSetupBackSelected() { return _bPlayerSetupBackSelected; }
		bool IsNewOrLoadGameBackSelected() { return _bNewOrLoadGameBackSelected; }

		virtual void OnUiButtonDown( SoUiButton* pButton );
		virtual void OnUiButtonUp( SoUiButton* pButton );
		virtual void OnUiButtonUpTouchOutside( SoUiButton* pButton ) {};
		virtual void OnUiButtonRub( SoUiButton* pButton ) {};

		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) { ccTouchesEnded(pTouches, pEvent); }

		virtual void OnMessageFromGui( SoGuiMessage* pMessage );

		static SoFsmSetupOfflineGameLayer* create();


	private:

		//-----------------------
		// private variables

		bool _bReadyToExitState;

		bool _bPlayerSetupOkSelected;
		bool _bPlayerSetupBackSelected;
		bool _bGameSetupStartSelected;
		bool _bGameSetupBackSelected;

		bool _bNewGameSelected;
		bool _bLoadGameSelected;
		bool _bNewOrLoadGameBackSelected;

		SoSpriteAnim* m_pAdvanceSprite;
		
		SoGuiManager _GuiManager;
		SoGuiListener< SoFsmSetupOfflineGameLayer > _GuiListener;
		guid _gGuiSetupPlayers;
		guid _gGuiNewOrLoadGame;
		guid _gGuiSetupGame;

		SoScreenFader* _pScreenFader;

		int _iCurrentState;

		SoGuiAnimWinSetupPlayers* _pWinSetupPlayers;
		SoGuiAnimWinNewOrLoadGame* _pWinNewOrLoadGame;
		SoGuiAnimWinSetupGame* _pWinSetupGame;

		SoWatermarkPreRelease _WatermarkPreRelease;

		//-----------------------
		// private functions
		int CountValidPlayers();
};