/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiManager.h"
#include "SoFsmState.h"
#include "SoScreenFader.h"
#include "SoUiButton.h"
#include "SoWatermark.h"


class SoGuiAnimWinCreateOrJoinGame;
class SoGuiAnimWinEnterGameName;
class SoGuiAnimWinSetupGame;
class SoGuiAnimWinSetupPlayers;
class SoFsmSetupOnlineGameLayer;
class SoSpriteAnim;


class SoFsmStateSetupOnlineGame : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateSetupOnlineGame();

		virtual ~SoFsmStateSetupOnlineGame();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmSetupOnlineGameLayer* _pLayer;
};






class SoFsmSetupOnlineGameLayer : public cocos2d::CCLayerColor
{
	public:

		//-----------------------
		// public functions

		SoFsmSetupOnlineGameLayer();
		virtual ~SoFsmSetupOnlineGameLayer();

		virtual bool init();
		void Deinit();

		virtual void update( float dt );
		virtual void draw();

		LAYER_NODE_FUNC(SoFsmSetupOnlineGameLayer);


		bool IsReadyToExitState() { return _bReadyToExitState; }
		bool IsStartGameSelected() { return _bGameSetupStartSelected; }
		bool IsJoinGameSelected() { return _bJoinGameSelected; }
		bool IsBackSelected() { return _bCreateOrJoinBackSelected; }

		virtual void OnUiButtonDown( SoUiButton* pButton );
		virtual void OnUiButtonUp( SoUiButton* pButton );
		virtual void OnUiButtonUpTouchOutside( SoUiButton* pButton ) {};
		virtual void OnUiButtonRub( SoUiButton* pButton ) {};

		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) { ccTouchesEnded(pTouches, pEvent); }

		virtual void OnMessageFromGui( SoGuiMessage* pMessage );

		static SoFsmSetupOnlineGameLayer* create();


	private:

		//-----------------------
		// private variables

		bool _bReadyToExitState;

		bool _bPlayerSetupOkSelected;
		bool _bPlayerSetupBackSelected;

		bool _bGameSetupStartSelected;
		bool _bGameSetupBackSelected;

		bool _bCreateGameSelected;
		bool _bJoinGameSelected;
		bool _bCreateOrJoinBackSelected;

		bool _bGameNameNextSelected;
		bool _bGameNameBackSelected;

		SoSpriteAnim* m_pAdvanceSprite;
		
		SoGuiManager _GuiManager;
		SoGuiListener< SoFsmSetupOnlineGameLayer > _GuiListener;

		SoGuiAnimWinCreateOrJoinGame* _pWinCreateOrJoinGame;
		guid _gWinCreateOrJoinGame;

		SoGuiAnimWinSetupPlayers* _pWinSetupPlayers;
		guid _gWinSetupPlayers;

		SoGuiAnimWinSetupGame* _pWinSetupGame;
		guid _gWinSetupGame;

		SoGuiAnimWinEnterGameName* _pWinEnterGameName;
		guid _gWinEnterGameName;


		SoScreenFader* _pScreenFader;

		int _iCurrentState;

		SoWatermarkPreRelease _WatermarkPreRelease;


		//-----------------------
		// private functions
		int CountValidPlayers();
};