/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiManager.h"
#include "SoFsmState.h"
#include "SoScreenFader.h"
#include "SoUiButton.h"
#include "SoWatermark.h"


class SoFsmShellLayer;
class SoSpriteAnim;

class SoFsmStateShell : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateShell();

		virtual ~SoFsmStateShell();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmShellLayer* _pLayer;
};






class SoFsmShellLayer : public cocos2d::CCLayerColor
{
	public:
		SoFsmShellLayer();
		virtual ~SoFsmShellLayer();

		virtual bool init();
		void Deinit();

		virtual void update( float dt );
		virtual void draw();

		LAYER_NODE_FUNC(SoFsmShellLayer);


		bool IsReadyToExitState() { return _bReadyToExitState; }
		bool IsFacebookSelected() { return _bFacebookSelected; }
		bool IsPlayOfflineSelected() { return _bPlayOfflineSelected; }
		bool IsPlayOnlineSelected() { return _bPlayOnlineSelected; }
		bool IsCreditsSelected() { return _bCreditsSelected; }
		bool IsTutorialSelected() { return _bTutorialSelected; }
		bool IsBackSelected() { return _bBackSelected; }

		virtual void OnUiButtonDown( SoUiButton* pButton );
		virtual void OnUiButtonUp( SoUiButton* pButton );
		virtual void OnUiButtonUpTouchOutside( SoUiButton* pButton ) {};
		virtual void OnUiButtonRub( SoUiButton* pButton ) {};

		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) { ccTouchesEnded(pTouches, pEvent); }

		virtual void OnMessageFromGui( SoGuiMessage* pMessage );

		static SoFsmShellLayer* create();


	private:

		bool _bReadyToExitState;

		bool _bFacebookSelected;
		bool _bPlayOfflineSelected;
		bool _bPlayOnlineSelected;
		bool _bCreditsSelected;
		bool _bTutorialSelected;
		bool _bOptionsSelected;
		bool _bRulesSelected;
		bool _bMoreSelected;
		bool _bBackSelected;

		SoSpriteAnim* m_pAdvanceSprite;
		
		SoGuiManager _GuiManager;
		SoGuiListener< SoFsmShellLayer > _GuiListener;
		guid _gGuiShellMain;
		guid _gGuiShellMainMore;
		guid _gGuiOptions;
		guid _gGuiRules;
		guid _gGuiWinStoreBadges;

		SoScreenFader* _pScreenFader;

		SoWatermarkPreRelease _WatermarkPreRelease;
		SoWatermarkBuildNumber _WatermarkBuildNumber;

		int _iCurrentState;
};