/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoFsmState.h"


class SoFsmTutorialLayer;
class SoSprite;

class SoFsmStateTutorial : public SoFsmState
{
	public:

		//-----------------------
		// public functions

		SoFsmStateTutorial();

		virtual ~SoFsmStateTutorial();


		virtual void Init();
		virtual void Deinit();
		virtual hash Update( float dt );


	private:

		//-----------------------
		// private variables


		SoFsmTutorialLayer* _pLayer;
};






class SoFsmTutorialLayer : public cocos2d::CCLayerColor
{
	public:
		enum eSubState
		{
			eSubState_Screen1,
			eSubState_Done,
			eSubState_Last
		};

		SoFsmTutorialLayer();
		virtual ~SoFsmTutorialLayer();

		virtual bool init();
		virtual void update( float dt );

		LAYER_NODE_FUNC(SoFsmTutorialLayer);

		bool IsDone();
		bool IsTouched() { return _bTouched; }


		virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
		virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);
		virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);


		static SoFsmTutorialLayer* create();

	private:
		bool _bTouched;
		float _fTimer;

		eSubState _eState;

		SoSprite* _pSplashSprite1;
};

















