/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include <float.h>

#include "JpHashTable.h"
#include "JpList.h"
#include "NeCompass.h"
#include "SoSprite.h"
#include "SoSpriteAnimSet.h"
#include "SoUtils.h"


USING_NS_CC;


#define SoGameBitList JpList< SoGameBit >


class SoGameBitBoard;
class SoGameBitBoardSpot;
class SoGameBitCard;
class SoGameBitHotel;
class SoGameBitPlayer;
class SoGameBitPlayerHuman;
class SoGameBitPlayerMcts;
class SoGameBitPlayerMctsRandom;
class SoGameBitTile;


class SoGameBit
{
	public:

		//-----------------------
		// public enums
		enum TYPE
		{
			TYPE_GAMEBIT,
			TYPE_GAMEBIT_BOARD,
			TYPE_GAMEBIT_BOARD_LOCATION,
			TYPE_GAMEBIT_BOARD_SPOT,
			TYPE_GAMEBIT_CARD,
			TYPE_GAMEBIT_HOTEL,
			TYPE_GAMEBIT_PLAYER,
			TYPE_GAMEBIT_PLAYER_AI,
			TYPE_GAMEBIT_PLAYER_DUMB,
			TYPE_GAMEBIT_PLAYER_HUMAN,
			TYPE_GAMEBIT_PLAYER_MCTS,
			TYPE_GAMEBIT_PLAYER_MCTS_HEURISTIC,
			TYPE_GAMEBIT_PLAYER_MCTS_RANDOM,
			TYPE_GAMEBIT_TILE,
			TYPE_GAMEBIT_WORKER,
			TYPE_GAMEBIT_LAST
		};

		//-----------------------
		// public functions
		SoGameBit();
		virtual ~SoGameBit() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT; }

		virtual SoGameBitBoard* GetAsBoard() { return NULL; }
		virtual SoGameBitBoardSpot* GetAsBoardSpot() { return NULL; }
		virtual SoGameBitCard* GetAsCard() { return NULL; }
		virtual SoGameBitHotel* GetAsHotel() { return NULL; }
		virtual SoGameBitPlayer* GetAsPlayer() { return NULL; }
		virtual SoGameBitPlayerHuman* GetAsPlayerHuman() { return NULL; }
		virtual SoGameBitPlayerMcts* GetAsPlayerMcts() { return NULL; }
		virtual SoGameBitPlayerMctsRandom* GetAsPlayerMctsRandom() { return NULL; }
		virtual SoGameBitTile* GetAsTile() { return NULL; }


	protected:

};


