/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpArray.h"
#include "JpList.h"
#include "SoGameBit.h"
#include "SoGameBitTile.h"


#define HOTEL_UNDEFINED_ID  -1
#define SoGameBitHotelList JpList< SoGameBitHotel >
#define SoGameBitHotelArray JpArray< SoGameBitHotel >


class SoGameBitHotel : public SoGameBit
{
	public:

		//-----------------------
		// public functions
		SoGameBitHotel();
		virtual ~SoGameBitHotel() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_HOTEL; }

		virtual SoGameBitHotel* GetAsHotel() { return this; }

		int GetHotelId() { return _iHotelId; }
		void SetHotelId( int i ) { _iHotelId = i; }

		int GetPlacementTileId() { return _iPlacementTileId; }
		void SetPlacementTileId( int i ) { _iPlacementTileId = i; }

		int GetSize() { return _iSize; }
		void SetSize( int i ) { _iSize = i; }

		bool IsSafe() { return ( _iSize > 10 ); }

		bool IsPlaced() { return _iPlacementTileId != TILE_UNDEFINED_ID; }

		int GetAvailableStock() { return _iAvailableStock; }
		void SetAvailableStock( int i ) { _iAvailableStock = i; }
		void AdjustAvailableStock( int i );

		static int GetPricePerStockFromTable( int iHotelId, int iHotelSize );
		static int GetMajorityBonusFromTable( int iHotelId, int iHotelSize );
		static int GetMinorityBonusFromTable( int iHotelId, int iHotelSize );

		static int GetTableColumnFromHotelSize( int iHotelSize );

		static int GetHotelPrestigeRating( int iHotelId );

		void MakeCopy( SoGameBitHotel* pSource );

	private:

		//-----------------------
		// private variables
		int _iHotelId;

		int _iPlacementTileId;

		int _iSize;

		int _iAvailableStock;

};


