/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGameBitPlayer.h"
#include "SoGameMessage.h"
#include "SoGameState.h"

class SoGameBitCardBomb;
class SoMctsTree;

class SoGameBitPlayerAi : public SoGameBitPlayer
{
	public:


		//-----------------------
		// public functions
		SoGameBitPlayerAi();
		virtual ~SoGameBitPlayerAi() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );
		virtual TYPE GetType() { return TYPE_GAMEBIT_PLAYER_AI; }

	private:

		//-----------------------
		// private variables
		SoMctsTree* _pMctsTree;


		//-----------------------
		// private functions
		virtual void SelectAction();
		virtual void DoSelectStockPurchase();
		virtual void DoSelectNewHotel();
		virtual void DoSelectMergeSurviorHotel();
		virtual void DoManageOldStock();

		void TakeTurnUsingMcts( SoGameState::STATE eServersSoGameState );
		SoMctsTree* PrepareMctsTree();
};


