/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/

#include "stdafx.h"

#include "SoActorManager.h"
#include "SoGameBitPlayerDumb.h"

#include "mmgrChooser.h"



/******************************************************************************
 FUNCTION:  SoActorPlayerDumb
******************************************************************************/
SoGameBitPlayerDumb::SoGameBitPlayerDumb()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGameBitPlayerDumb::Init( CCNode* pParentNode )
{
	SoGameBitPlayer::Init( pParentNode );

	// The Mcts Simulation makes copies of Dumb players if the current client
	// has any.  The copy includes state and requested state settings, so
	// even though this is just a Dumb player, we should make sure the state
	// and requested state make sense.
	// mdomowicz 2013_09_30
	_eState = STATE_INIT;
	_eRequestedState = STATE_LAST;
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGameBitPlayerDumb::Deinit()
{	
	SoGameBitPlayer::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGameBitPlayerDumb::Update( float dt )
{
	SoGameBitPlayer::Update( dt );


	// This is the minimum state handling needed to make sure the Mcts simulation,
	// when simulating for a Dump Player, still works.
	// mdomowicz 2013_09_30
	switch ( _eState )
	{
		case STATE_INIT:
		{
			//CPrintF( "Player %i, waiting...", _iPlayerNumber + 1 );
			_eState = STATE_WAIT;
			break;
		}

		case STATE_WAIT:
		{
			break;
		}

		default:
			break;
	}
}



