/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGameBitPlayer.h"



class SoGameBitPlayerDumb : public SoGameBitPlayer
{
	public:


		//-----------------------
		// public functions
		SoGameBitPlayerDumb();
		virtual ~SoGameBitPlayerDumb() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_PLAYER_DUMB; }

		virtual SoGameBitPlayerDumb* GetAsPlayerDumb() { return this; }


		// SoGame will command changes of state, but since this is a Dumb Player that cannot
		// do anything with state change requests, we disable them.  This prevents a hang
		// in the SoTreeMcts during Simulation for Dumb Players, because now the Dumb Players can
		// never be in an unexpected state (and therefore the copies of the Dumb Players cannot
		// be in an unexpected state either).
		// mdomowicz 2013_09_30
		virtual void CommandSelectAction() {};
		virtual void CommandSelectStockPurchases() {};
		virtual void CommandSelectNewHotel() {};
		virtual void CommandSelectMergeHotels() {};
		virtual void CommandSelectManageOldStock() {};

	private:
};


