/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoCodec.h"
#include "SoGameBitPlayer.h"
#include "SoGameMessage.h"
#include "SoGuiManager.h"
#include "SoWorkerParkingSpot.h"


class SoGuiAnimWinPlayerBar;
class SoGuiMessage;


class SoGameBitPlayerHuman : public SoGameBitPlayer
{
	public:


		//-----------------------
		// public functions
		SoGameBitPlayerHuman();
		virtual ~SoGameBitPlayerHuman() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_PLAYER_HUMAN; }

		virtual SoGameBitPlayerHuman* GetAsPlayerHuman() { return this; }

		SoWorkerParkingSpotList* GetWorkerParkingSpotList() { return &_WorkerParkingSpotList; }


		// callback from GuiListener
		virtual void OnMessageFromGui( SoGuiMessage* pMessage );


		bool GetIsViewTilesToggleOn() { return _bIsViewTilesToggleOn; }

		void UpdateAllParkingSpots( float dt );

	private:

		//-----------------------
		// private variables
		SoGameMessage _Message;
		SoCodecPlyrMoveStockPurchases _StockPurchasesEncoder;
		SoCodecPlyrMoveNewHotelPick _NewHotelPickEncoder;
		SoCodecPlyrMoveMergeHotels _MergeHotelsEncoder;
		SoCodecPlyrManageOldStock _ManageOldStockEncoder;
		SoCodecPlyrMoveDeclareLastTurn _DeclareLastTurnEncoder;

		SoWorkerParkingSpotList _WorkerParkingSpotList;

		SoGuiAnimWinPlayerBar* _pGuiPlayerBar;
		guid _gGuiPlayerBar;
		guid _gWindowNewHotelChoice;
		guid _gWindowMergeHotelChoice;
		guid _gWindowStockPurchase;
		guid _gWindowManageOldStock;
		guid _gWindowDeclareLastTurn;
		guid _gWindowMessageBox2;

		guid _gWindowUniversityHires;
		guid _gWindowParkingSpotInput;

		SoGuiListener< SoGameBitPlayerHuman > _GuiListener;
		std::string _sGuiMessageData;

		float _fCancelActionTimer;


		bool _bIsViewTilesToggleOn;

		//-----------------------
		// private functions
		void PrintToConsole( const std::string& s );
		void CPrintF( const char* pFormat, ... );

		SoWorkerParkingSpot* GetParkingSpotClickedByUser();
		void CreateParkingSpotsForAvailableActions();
		void RemoveAndDeleteAllWorkerParkingSpots();

		void LaunchWindowNewHotelChoice();
		void LaunchWindowMergeSurvivorHotelChoice();
		void LaunchWindowMergeVictimHotelChoice();
		void LaunchWindowStockPurchase();
		void LaunchWindowManageOldStock();
		void LaunchWindowDeclareLastTurn();
		void LaunchWindowMessageBox2( const std::string& sWindowText );

		void MoveCameraToStandardPosAndZoom();
		void MoveCameraToOpenWindowPosAndZoom();
		void SetupCameraOnStartOfPlayersTurn();
		void SetupCameraOnEndOfPlayersTurn();
};


