/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoCodec.h"
#include "SoGameBitPlayer.h"
#include "SoGameMessage.h"
#include "SoGuiManager.h"


class SoGuiMessage;


class SoGameBitPlayerMcts : public SoGameBitPlayer
{
	public:

		enum MESSAGE_TARGET
		{
			MESSAGE_TARGET_SERVER,
			MESSAGE_TARGET_MCTS_TREE,
			MESSAGE_TARGET_LAST
		};

		//-----------------------
		// public functions
		SoGameBitPlayerMcts();
		virtual ~SoGameBitPlayerMcts() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_PLAYER_MCTS; }

		virtual SoGameBitPlayerMcts* GetAsPlayerMcts() { return this; }

		void SetMessageTarget( MESSAGE_TARGET e ) { _eMessageTarget = e; }

		SoGameMessage* GetLastSentMessage();
		void ClearLastSentMessage() { _LastSentMessage.Clear(); };

		bool IsInMoveSelectionState();
		void AdvanceToMoveSelectionState();

		bool IsInWaitState();
		void AdvanceToWaitState();


	protected:

		//-----------------------
		// protected variables
		MESSAGE_TARGET _eMessageTarget;

		SoGameMessage _Message;
		SoGameMessage _LastSentMessage;


		//-----------------------
		// protected functions
		virtual void SelectAction();

		virtual void DoTilePlacement();
		virtual void DoSelectStockPurchase();
		virtual void DoSelectNewHotel();
		virtual void DoSelectMergeSurviorHotel();
		virtual void DoManageOldStock();
		virtual void DoDeclareLastTurn();
		virtual void DoEndTurn();




		void SendMessageToMessageTarget( SoGameMessage& Message );

		void PrintToConsole( const std::string& s );
		void CPrintF( const char* pFormat, ... );

};


