/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGameBitPlayerMcts.h"


class SoGuiMessage;


class SoGameBitPlayerMctsHeuristic : public SoGameBitPlayerMcts
{
	public:

		//-----------------------
		// public functions
		SoGameBitPlayerMctsHeuristic();
		virtual ~SoGameBitPlayerMctsHeuristic() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_PLAYER_MCTS_HEURISTIC; }

		virtual SoGameBitPlayerMctsHeuristic* GetAsPlayerMctsHeuristic() { return this; }


	protected:
		//-----------------------
		// protected functions
		virtual void SelectAction();

		virtual void DoTilePlacement();
		virtual void DoSelectStockPurchase();
		virtual void DoSelectNewHotel();
		virtual void DoSelectMergeSurviorHotel();
		virtual void DoManageOldStock();
		virtual void DoDeclareLastTurn();
		virtual void DoEndTurn();


		bool CanWinIfTurnEndsNow();

	private:

		//-----------------------
		// private variables
		int _aiStockOwnershipStatus[ GAMERULES_NUM_HOTELS ];	
		int _aiMostStockOwnedPerHotel[ GAMERULES_NUM_HOTELS ];	
		int _aiSecondMostStockOwnedPerHotel[ GAMERULES_NUM_HOTELS ];

		SoGameBitTileArray _PlaceableTilesInHandArray;


		//-----------------------
		// private functions
		int ScoreTilePlacement( SoGameBitTile* pTile );
		int ScoreTilePlacementIfItMergesHotels( SoGameBitTile* pTile );

		int ScoreMergedHotel( int iHotelId );

		bool DoesTileExtendHotelChainIOwn( int* piScoreResult, SoGameBitTile* pTile );
		int GetScoreForPairingWithOtherTilesIOwn( SoGameBitTile* pTile );

		void UpdateStockCountStats();
		void UpdatePlaceableTilesInHandArray();

		void ManageOldStockRandomly( int* piAmountToKeepResult, int* piAmountToTradeResult, int* piAmountToSellResult, int iAmountAvailable );
};


