/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/

#include "stdafx.h"

#include "SoActorManager.h"
#include "SoActorVisibleTile.h"
#include "SoGameBitPlayer.h"
#include "SoGameBitTile.h"

#include "mmgrChooser.h"



/******************************************************************************
 FUNCTION:  SoActorCard
******************************************************************************/
SoGameBitTile::SoGameBitTile() :
_iId( TILE_UNDEFINED_ID ),
_iTileX( -1 ),
_iTileY( -1 ),
_iHotelId( HOTEL_UNDEFINED_ID ),
_iOwnerPlayerNumber( PLAYER_UNDEFINED_PLAYER_NUMBER ),
_bIsPlaced( false ),
_bIsCounted( false ),
_gActorVisibleTile( 0 )
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGameBitTile::Init( CCNode* pParentNode )
{
	SoGameBit::Init( pParentNode );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGameBitTile::Deinit()
{	
	SoGameBit::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGameBitTile::Update( float dt )
{
	SoGameBit::Update( dt );
}



/******************************************************************************
 FUNCTION:  MakeCopy
******************************************************************************/
void SoGameBitTile::MakeCopy( SoGameBitTile* pSource )
{
	_iId                = pSource->_iId;
	_iTileX             = pSource->_iTileX;
	_iTileY             = pSource->_iTileY;
	_iHotelId           = pSource->_iHotelId;
	_iOwnerPlayerNumber = pSource->_iOwnerPlayerNumber;
	_bIsPlaced          = pSource->_bIsPlaced;

	_gActorVisibleTile  = pSource->_gActorVisibleTile;

	// This is a temp variable, not used by the rules, and does not
	// need to be copied.
	// _bIsCounted
}



/******************************************************************************
 FUNCTION:  GetActorVisibleTile
******************************************************************************/
SoActorVisibleTile* SoGameBitTile::GetActorVisibleTile()
{
	SoActorManager* pActorManager = SoActorManager::GetInstance();
	SoActor* pActor = pActorManager->GetActorByGuid( _gActorVisibleTile );

	if ( pActor )
	{
		return pActor->GetAsVisibleTile();
	}

	return NULL;
}



/******************************************************************************
 FUNCTION:  SetActorVisibleTile
******************************************************************************/
void SoGameBitTile::SetActorVisibleTile( SoActorVisibleTile* p )
{
	if ( p )
		_gActorVisibleTile = p->GetGuid();
}
