/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpArray.h"
#include "JpList.h"
#include "SoGameBit.h"


#define TILE_UNDEFINED_ID  -1
#define SoGameBitTileList JpList< SoGameBitTile >
#define SoGameBitTileArray JpArray< SoGameBitTile >


class SoActorVisibleTile;


class SoGameBitTile : public SoGameBit
{
	public:


		//-----------------------
		// public functions
		SoGameBitTile();
		virtual ~SoGameBitTile() {}

		virtual void Init( CCNode* pParentNode ); 
		virtual void Deinit();

		virtual void Update( float dt );

		virtual TYPE GetType() { return TYPE_GAMEBIT_TILE; }

		virtual SoGameBitTile* GetAsTile() { return this; }

		int GetId() { return _iId; }
		void SetId( int i ) { _iId = i; }

		int GetTileX() { return _iTileX; }
		void SetTileX( int i ) { _iTileX = i; }

		int GetTileY() { return _iTileY; }
		void SetTileY( int i ) { _iTileY = i; }

		int GetHotelId() { return _iHotelId; }
		void SetHotelId( int i ) { _iHotelId = i; }

		int GetOwnerPlayerNumber() { return _iOwnerPlayerNumber; }
		void SetOwnerPlayerNumber( int i ) { _iOwnerPlayerNumber = i; }

		bool IsPlaced() { return _bIsPlaced; }
		void SetIsPlaced( bool b ) { _bIsPlaced = b; }

		bool IsCounted() { return _bIsCounted; }
		void SetIsCounted( bool b ) { _bIsCounted = b; }

		SoActorVisibleTile* GetActorVisibleTile();
		void SetActorVisibleTile( SoActorVisibleTile* p );

		void MakeCopy( SoGameBitTile* pSource );

	private:

		//-----------------------
		// private variables
		int _iOwnerPlayerNumber;
		bool _bIsPlaced;

		int _iId;
		int _iTileX;
		int _iTileY;

		int _iHotelId;

		bool _bIsCounted;

		guid _gActorVisibleTile;
};


