/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoConsole.h"
#include "SoGameClient.h"
#include "SoGameServer.h"
#include "SoNetworkComms.h"


USING_NS_CC;

class SoGuiAnimWinLog;


class SoGameGlobals
{
	public:

		//-----------------------
		// public functions

		SoGameGlobals();

		virtual ~SoGameGlobals();

		static void Init();

		static void Deinit();

		static void Update( float dt );


		static void CreateNetworkCommsOnline();
		static void CreateNetworkCommsOffline();
		static SoNetworkComms* GetNetworkComms() { return _pNetworkComms; }

	
		static void CreateServer( const std::string& sServerName );
		static void CreateServerForLoadGame( hash hServerId, hash hMasterRngSeed );
		static SoGameServer* GetServer() { return _pGameServer; }


		static SoGameClient* CreateClient();
		static SoGameClientList* GetClientList() { return &_GameClientList; }


		static SoGuiAnimWinLog* GetGuiAnimWinLog() { return _pGuiAnimWindowLog; }
		static void SetGuiAnimWinLog( SoGuiAnimWinLog* p ) { _pGuiAnimWindowLog = p; }

		static bool IsLoadingGame() { return _bIsLoadingGame; }
		static void SetIsLoadingGame( bool b ) { _bIsLoadingGame = b; }
		static bool DoesSaveGameExist();

	private:

		//-----------------------
		// private variables

		static SoGameServer* _pGameServer;		
		static SoGameClientList _GameClientList;

		static SoNetworkComms* _pNetworkComms;

		static SoGuiAnimWinLog* _pGuiAnimWindowLog;

		static bool _bIsLoadingGame;
};




