/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpChecksum.h"

#include "SoCardDeck.h"
#include "SoGameBitPlayer.h"
#include "SoGameMessage.h"
#include "SoGameState.h"



USING_NS_CC;



class SoGameStateMcts : public SoGameState
{
	public:


		//-----------------------
		// public functions

		SoGameStateMcts();

		virtual ~SoGameStateMcts();

		virtual void MakeCopy( SoGameState* pSource, SoGameBitPlayer::AI_PLAYER_STRENGTH eDesiredAiPlayerStrength );

		void Init();

		void Deinit();

		bool UpdateFromServer( SoGameMessage* pInMsg );

		virtual SoGameStateMcts* GetAsGameStateMcts() { return this; }

		void Simulate();
		void SimulateUntilNextPlayerMoveCommand();

		void Evaluate();

		float GetPlayerEvaluation( int iPlayerNumber );

		virtual void SendMessageToAllClients( SoGameMessage& M );
		virtual void SendMessageToServer( SoGameMessage& M );

		void DeleteMessageLists();

		void SetCurrentState( STATE e ) { _eCurrentState = e; }

		ChecksumUint32 CalculateChecksumForMcts();

		void WriteAllDataToDisk( char* pacFilename );

	private:

		//-----------------------
		// private variables
		SoGameMessageList _MessagesForServers;
		SoGameMessageList _MessagesForClients;

		float _afPlayerEvaluations[ GAMERULES_MAX_PLAYERS ];


		//-----------------------
		// private functions

		virtual void CaptureUndoState();
		virtual void PrintToConsole( const std::string& s );
};




