/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"


#include "NeCsvIn.h"
#include "SoActorManager.h"
#include "SoGameBitPlayerDumb.h"
#include "SoGameGlobals.h"
#include "SoGameStateUndo.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoGameMcts
******************************************************************************/
SoGameStateUndo::SoGameStateUndo()
{
}



/******************************************************************************
 FUNCTION:  ~SoGameMcts
******************************************************************************/
SoGameStateUndo::~SoGameStateUndo()
{
	Deinit();
}



/******************************************************************************
 FUNCTION:  MakeCopy
******************************************************************************/
void SoGameStateUndo::MakeCopy( SoGameState* pSource )
{
	//-----------------------
	// copy the internal data
	MakeCopyHelperForUndo( pSource );


	//-----------------------
	// make a dumb copy of every player
	SoGameBitPlayerArray::Iterator PlayerIter( pSource->GetPlayerArray() );
	while ( PlayerIter.Next() )
	{
		SoGameBitPlayer* pPlayer = PlayerIter.GetData();
		SoGameBitPlayerDumb* pNewPlayer = new SoGameBitPlayerDumb;

		pNewPlayer->Init( SoActorManager::GetInstance()->GetParentNode() );
		pNewPlayer->MakeCopy( pPlayer );
		pNewPlayer->SetOwningGame( this );

		_PlayerArray.AddLast( pNewPlayer );
	}
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGameStateUndo::Init()
{
	SoGameState::Init();
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGameStateUndo::Deinit()
{
	// Note: right now the parent class Deinit is called by
	// the parent class' destructor, so we don't do it here.
	// mdomowicz 2013_10_10
	//SoGame::Deinit()
}
