/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnim.h"
#include "SoGuiAnimButton.h"

USING_NS_CC;


class SoGuiAnimSlider : public SoGuiAnim
{
	public:

		//-----------------------
		// public classes
		class SetupParams
		{
			public:
				SetupParams() :
				_vRelativePos( 0.0f, 0.0f ),
				_vLabelPosition( 0.0f, 0.0f ),
				_fInitialValue( 1.0f ),
				_fLength( 0.0f ),
				_bIsDisabled( false )
				{};

				virtual ~SetupParams(){};

				SoGuiAnimButton::SetupParams _ButtonParams;
				JpVector2f _vRelativePos;
				JpVector2f _vLabelPosition;
				std::string _sBackgroundFilename;
				std::string _sLabel;
				float _fInitialValue;
				float _fLength;
				bool _bIsDisabled;
		};


		//-----------------------
		// public functions

		SoGuiAnimSlider();

		virtual ~SoGuiAnimSlider();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		virtual SoGuiAnimSlider* GetAsAnimSlider() { return this; }

		void Setup( const SetupParams& Params );

		void SetUseWorldSpacePositioning( bool b ) { _bUseWorldSpacePositioning = b; }
		void SetWorldPosition( const JpVector2f& v ) { _vWorldPosition = v; }

		float GetValue() { return _fValue; }
		void SetValue( float fValue );

		// SoInputTouch callbacks
		virtual bool OnTouchesDown( const SoCcTouchList* pSoCcTouchList );
		virtual bool OnTouchesUp( const SoCcTouchList* pSoCcTouchList );
		virtual bool OnTouchesMove( const SoCcTouchList* pSoCcTouchList );

		void SetLabelText( std::string& sText );


	protected:

		//-----------------------
		// protected variables

		bool _bUseWorldSpacePositioning;
		
		JpVector2f _vWorldPosition;
		JpVector2f _vLabelPosition;

		JpVector2f _vButtonPosCurrent;
		JpVector2f _vButtonPosCentered;

		float _fLength;
		float _fValue;

		guid _gSliderButton;

		SoLabelBmFont* _pLabel;

		bool _bIsDisabled;

		//-----------------------
		// protected functions
		JpVector2f GetScreenPositionFromWorldSpace( JpVector2f vWorldPosition );
};




