/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"

USING_NS_CC;


class SoGuiAnimWinConfirm : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinConfirm();

		virtual ~SoGuiAnimWinConfirm();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetWindowText( const std::string& s );

		// If this window is showing, then all input is considered "handled".
		// This helps SoGuiManager and SoInputDispatcher control when input should/shouldn't be
		// sent to other systems.  mdomowicz 2013_11_03
		virtual bool OnTouchesMove( const SoCcTouchList* pSoCcTouchList ) { return IsShowing(); }
		virtual bool OnTouchesDown( const SoCcTouchList* pSoCcTouchList )  { return IsShowing(); }
		virtual bool OnTouchesUp( const SoCcTouchList* pSoCcTouchList ) { return IsShowing(); }


		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }



	protected:

		//-----------------------
		// protected variables
		SoLabelBmFont* _pLabel;

		guid _gButtonCancel;
		guid _gButtonOk;

		std::string _sWindowText;


		//-----------------------
		// protected functions

		void HandleWindowExit();
		void HandleConfirm();
};




