/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"

USING_NS_CC;


class SoGuiAnimWinCoreMain : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinCoreMain();

		virtual ~SoGuiAnimWinCoreMain();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );


		// This is a really hacky way for other menus to know if this window
		// is open.  mdomowicz 2014_02_24
		static bool IsCoreMainWindowOpen() { return _bIsCoreMainWindowOpen; }


		// If this window is showing, then all input is considered "handled".
		// This helps SoGuiManager and SoInputDispatcher control when input should/shouldn't be
		// sent to other systems.  mdomowicz 2013_11_03
		virtual bool OnTouchesMove( const SoCcTouchList* pSoCcTouchList ) { return IsShowing(); }
		virtual bool OnTouchesDown( const SoCcTouchList* pSoCcTouchList )  { return IsShowing(); }
		virtual bool OnTouchesUp( const SoCcTouchList* pSoCcTouchList ) { return IsShowing(); }

		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }

	protected:

		//-----------------------
		// protected variables
		guid _gButtonOptions;
		guid _gButtonRules;
		guid _gButtonQuitGame;
		guid _gButtonCloseWindow;

		static bool _bIsCoreMainWindowOpen;
};




