/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"
#include "SoGuiChat.h"

#define GUI_CHAT_ENABLED 0

USING_NS_CC;

class SoGuiAnimWinConfirm;

class SoGuiAnimWinCoreMainLauncher : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinCoreMainLauncher();

		virtual ~SoGuiAnimWinCoreMainLauncher();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }

	protected:

		//-----------------------
		// protected variables

		guid _gButtonQuestionMark;
		guid _gWindowCoreMain;
		guid _gGuiOptions;
		guid _gGuiRules;
		guid _gGuiConfirmQuit;

		guid _gButtonViewLog;
		guid _gWindowLog;

		SoGuiAnimWinConfirm* _pWinComfirm;

		#if GUI_CHAT_ENABLED
			SoGuiChat* _pGuiChat;
		#endif

		bool _bKeypadBackButtonPressed;
		bool _bQuestionMarkButtonPressed;
		bool _bOptionsButtonPressed;
		bool _bRulesButtonPressed;
		bool _bCloseWindowButtonPressed;
		bool _bViewLogButtonPressed;
		bool _bBackButtonPressed;
		bool _bQuitGameButtonPressed;
		bool _bCancelButtonPressed;
		bool _bOkButtonPressed;

		int _iCurrentState;
};




