/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoGuiAnimButton.h"
#include "SoGuiAnimWinCreateOrJoinGame.h"
#include "SoGuiManager.h"
#include "SoGuiMessage.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoGuiWindowShellMain
******************************************************************************/
SoGuiAnimWinCreateOrJoinGame::SoGuiAnimWinCreateOrJoinGame() :
_gButtonCreateGame( 0 ),
_gButtonJoinGame( 0 ),
_gButtonBack( 0 )
{
}



/******************************************************************************
 FUNCTION:  ~SoGuiWindowShellMain
******************************************************************************/
SoGuiAnimWinCreateOrJoinGame::~SoGuiAnimWinCreateOrJoinGame()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGuiAnimWinCreateOrJoinGame::Init( CCNode* pParentNode, SoGuiManager* pGuiManager )
{
	SoGuiAnimWin::Init( pParentNode, pGuiManager );

	CreateBackgroundSprite( SoUtils::AddRelativePathToTexture( "GuiWindowBgLarge.png" ) );

	SetSpriteAlpha( 0.85f );

	SetPositionToCenterOfParent();
	//SetWidth( 600.0f );
	//SetHeight( 100.0f );

	SetTransitionStyle( SoGuiAnim::TRANSITION_STYLE_POP_UP );	



	SoGuiAnimButton::SetupParams ButtonParams;
	ButtonParams._hSoundEffectOnButtonUp = ( 0x5f1a7f2a /* "SfxSelect2.wav" */ );
	ButtonParams._eButtonDownImageOption = SoGuiAnimButton::BUTTON_DOWN_IMAGE_OPTION_SCALE_THE_UP_IMAGE_DOWN;


	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "GuiButtonCreateGameUp.png" );
	ButtonParams._vRelativePos.Init( 0 * SoUtils::GetiPadRatioX(), 150 * SoUtils::GetiPadRatioY() );
	_gButtonCreateGame = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );

	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "GuiButtonJoinGameUp.png" );
	ButtonParams._vRelativePos.Init( 0 * SoUtils::GetiPadRatioX(), 75 * SoUtils::GetiPadRatioY() );
	_gButtonJoinGame = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );


	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "GuiButtonBackUp.png" );
	ButtonParams._vRelativePos.Init( 0 * SoUtils::GetiPadRatioX(), -150 * SoUtils::GetiPadRatioY() );
	_gButtonBack = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGuiAnimWinCreateOrJoinGame::Deinit()
{
	SoGuiAnimWin::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGuiAnimWinCreateOrJoinGame::Update( float dt )
{
	SoGuiAnimWin::Update( dt );
}



/******************************************************************************
 FUNCTION:  HandleMessage
******************************************************************************/
void SoGuiAnimWinCreateOrJoinGame::HandleMessage( SoGuiMessage* pMessage )
{
	switch ( pMessage->GetType() )
	{
		case SoGuiMessage::TYPE_BUTTON_ON_DOWN:
		{
			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP:
		{
			if ( pMessage->GetSendersGuid() == _gButtonCreateGame )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "CreateGameButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}

			if ( pMessage->GetSendersGuid() == _gButtonJoinGame )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "JoinGameButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}


			if ( pMessage->GetSendersGuid() == _gButtonBack )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "CreateOrJoinBackButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}


			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP_TOUCH_OUTSIDE:
		{
			break;
		}
		default:
		{
			SoGuiAnimWin::HandleMessage( pMessage );
			break;
		}
	}
}



/******************************************************************************
 FUNCTION:  OnKeypadBackClicked
******************************************************************************/
bool SoGuiAnimWinCreateOrJoinGame::OnKeypadBackClicked()
{
	if ( IsShowing() )
	{
		SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
		GuiMessageForListener.AddHash( JpHash( "CreateOrJoinBackButtonPressed" ) );
		SendMessageToListeners( &GuiMessageForListener );
	}

	return true;
}
