/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoCurl.h"
#include "SoGuiAnimWin.h"

USING_NS_CC;


class SoGuiAnimTextEntry;


class SoGuiAnimWinEnterGameName : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public enums
		enum STATE
		{
			STATE_WAIT,
			STATE_TEST_SERVER_EXISTS,
			STATE_WAIT_FOR_TEST_SERVER_EXISTS_RESULT,
			STATE_TEST_IS_SERVER_JOINABLE,
			STATE_WAIT_FOR_TEST_IS_SERVER_JOINABLE_RESULT,
			STATE_LAST
		};

		//-----------------------
		// public functions

		SoGuiAnimWinEnterGameName();

		virtual ~SoGuiAnimWinEnterGameName();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetIsCreatingServer( bool b );
		void SetIsJoiningServer( bool b );

		const char* GetEnteredGameName();


		// SoCurl callback
		virtual void OnCurlDataReceived( const std::string& sData );


		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }

	protected:

		//-----------------------
		// protected variables
		SoCurlListener< SoGuiAnimWinEnterGameName > _CurlListener;

		SoLabelBmFont* _pLabel;
		SoLabelBmFont* _pLabelOnError;

		bool _bIsCreatingServer;
		bool _bIsJoiningServer;

		SoGuiAnimTextEntry* _pTextEntry;
		guid _gTextEntry;

		guid _gButtonBack;
		guid _gButtonNext;

		guid _gButtonClearText;

		bool _bNextPressed;
		STATE _eState;

		std::string _sCurlResult;

		//-----------------------
		// protected functions
		std::string GenerateRandomServerName();
};




