/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoConsole.h"
#include "SoFontDefs.h"
#include "SoGameBitPlayer.h"
#include "SoGameState.h"
#include "SoGuiAnimButton.h"
#include "SoGuiAnimWinMessageBox.h"
#include "SoGuiManager.h"
#include "SoGuiMessage.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoGuiAnimWinMessageBox
******************************************************************************/
SoGuiAnimWinMessageBox::SoGuiAnimWinMessageBox() :
_pGame( NULL )
{
}



/******************************************************************************
 FUNCTION:  ~SoGuiAnimWinMessageBox
******************************************************************************/
SoGuiAnimWinMessageBox::~SoGuiAnimWinMessageBox()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGuiAnimWinMessageBox::Init( CCNode* pParentNode, SoGuiManager* pGuiManager )
{
	SoGuiAnimWin::Init( pParentNode, pGuiManager );

	CreateBackgroundSprite( SoUtils::AddRelativePathToTexture( "GuiWindowBgSmall2.png" ) );

	SetSpriteAlpha( 0.85f );
	//SetPositionToCenterOfParent();

	SetRelativePos( JpVector2f( 0.0f, -220.0f * SoUtils::GetiPadRatioY() ) );

	//SetWidth( 922.0f * SoUtils::GetiPadRatioX() );
	//SetHeight( 75.0f * SoUtils::GetiPadRatioY() );

	SetTransitionStyle( SoGuiAnim::TRANSITION_STYLE_POP_UP );	


	_pLabel = CreateBmFontLabel( "", SoFontDefs::GetGuiDefault() );
	_pLabel->setOpacity( 255 );
	_pLabel->setAnchorPoint( ccp( 0.5, 0.0f ) );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGuiAnimWinMessageBox::Deinit()
{
	SoGuiAnimWin::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGuiAnimWinMessageBox::Update( float dt )
{
	SoGuiAnimWin::Update( dt );

	JpVector2f vLabelPos = _vAbsolutePos;
	vLabelPos.X -= 0.0f * SoUtils::GetiPadRatioX();
	vLabelPos.Y -= 15.0f * SoUtils::GetiPadRatioY();

	_pLabel->SetPosition( vLabelPos );
}



/******************************************************************************
 FUNCTION:  HandleMessage
******************************************************************************/
void SoGuiAnimWinMessageBox::HandleMessage( SoGuiMessage* pMessage )
{
	switch ( pMessage->GetType() )
	{
		case SoGuiMessage::TYPE_BUTTON_ON_DOWN:
		{
			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP:
		{
			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP_TOUCH_OUTSIDE:
		{
			break;
		}

		default:
		{
			SoGuiAnimWin::HandleMessage( pMessage );
			break;
		}
	}
}



/******************************************************************************
 FUNCTION:  SetLabelText
******************************************************************************/
void SoGuiAnimWinMessageBox::SetLabelText( std::string& sText )
{
	if ( _pLabel )
		_pLabel->setString( sText.c_str() );
	
}



