/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"

USING_NS_CC;


class SoGameBitPlayer;


class SoGuiAnimWinPlayerBar : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinPlayerBar();

		virtual ~SoGuiAnimWinPlayerBar();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetPlayer( SoGameBitPlayer* p ) { _pPlayer = p; }

		void UntoggleViewTilesToggle();

		bool IsViewSettingMin() { return _bIsViewSettingMin; }

	protected:

		//-----------------------
		// protected variables

		guid _gButtonEndTurn;

		guid _gButtonUndo;
		guid _gButtonResetTurn;
		guid _gButtonNegotiate;
		guid _gButtonBuildBomb;
		guid _gButtonBuyStock;
		guid _gButtonDeclareLastTurn;
		guid _gToggleViewTiles;
		guid _gComboButtonViewSetting;

		guid _gWindowCoreMain;

		SoGameBitPlayer* _pPlayer;

		int _iViewTilesToggleState;

		bool _bIsViewSettingMin;

		//-----------------------
		// protected functions
		void SendMessageToAllChildrenExcept( SoGuiMessage* pMessage, guid gExceptThisGui );

		bool DoesPlayerOwnAnyTiles();

		void UpdateViewToggle( float dt );

		void SwitchViewToDesiredStandardPosition( bool bIsViewSettingMin );
};




