/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


#include "SoGuiAnimWin.h"
#include "SoHudNumber.h"

USING_NS_CC;



class SoGameState;
class SoLabelBmFont;

class SoGuiAnimWinPlayerManageOldStock : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinPlayerManageOldStock();

		virtual ~SoGuiAnimWinPlayerManageOldStock();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetPlayerNumber( int i ) { _iPlayerNumber = i; }

		void SetGame( SoGameState* p ) { _pGame = p; }

	protected:

		//-----------------------
		// protected variables
		guid _gButtonOk;
		guid _gButtonCancel;

		guid _gButtonSellUp;
		guid _gButtonSellDown;
		guid _gButtonTradeUp;
		guid _gButtonTradeDown;

		SoHudNumber _HudNumberKeep;
		SoHudNumber _HudNumberSell;
		SoHudNumber _HudNumberTrade;

		int _iAmountAvailable;
		int _iAmountToKeep;
		int _iAmountToSell;
		int _iAmountToTrade;

		int _iAmountSurviorHotelStockAvailable;


		int _iPlayerNumber;

		SoLabelBmFont* _pLabel;

		SoLabelBmFont* _pLabelKeep;
		SoLabelBmFont* _pLabelSell;
		SoLabelBmFont* _pLabelTrade;

		SoGameState* _pGame;


		//-----------------------
		// protected functions
};




