/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


#include "SoGuiAnimWin.h"

USING_NS_CC;



class SoGameState;
class SoLabelBmFont;

class SoGuiAnimWinPlayerMergeHotelChoice : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public enums
		enum USAGE_TYPE
		{
			USAGE_TYPE_PICK_SURVIVOR_HOTEL,
			USAGE_TYPE_PICK_VICTIM_HOTEL,
			USAGE_TYPE_LAST
		};


		//-----------------------
		// public functions

		SoGuiAnimWinPlayerMergeHotelChoice();

		virtual ~SoGuiAnimWinPlayerMergeHotelChoice();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetPlayerNumber( int i ) { _iPlayerNumber = i; }

		void SetGame( SoGameState* p ) { _pGame = p; }

		void SetUsageType( USAGE_TYPE e ) { _eUsageType = e; }

		void SetSurvivingHotelId( int i ) { _iSurvivingHotelId = i; }


	protected:

		//-----------------------
		// protected variables
		guid _gButtonOk;
		guid _gButtonCancel;

		guid _agToggles[ GAMERULES_NUM_HOTELS ];

		int _iPlayerNumber;

		int _iSurvivingHotelId;

		SoLabelBmFont* _pLabel;

		SoGameState* _pGame;

		USAGE_TYPE _eUsageType;


		//-----------------------
		// protected functions
		void UnToggleAllGuisExcept( guid gExceptionGui );
		bool IsToggleOn( guid gGui );
};




