/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


#include "SoGuiAnimButton.h"
#include "SoGuiAnimWin.h"

USING_NS_CC;



class SoGameState;
class SoLabelBmFont;

class SoGuiAnimWinPlayerStockPurchase : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinPlayerStockPurchase();

		virtual ~SoGuiAnimWinPlayerStockPurchase();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetPlayerNumber( int i ) { _iPlayerNumber = i; }

		void SetGame( SoGameState* p ) { _pGame = p; }

	protected:

		//-----------------------
		// protected variables
		guid _gButtonOk;
		guid _gButtonCancel;

		int _iPlayerNumber;
		int _iPlayerMoney;

		SoLabelBmFont* _pLabel;
		SoLabelBmFont* _pLabelMoneyAvailable;
		SoLabelBmFont* _pLabelTotalCost;

		SoGameState* _pGame;


		SoGuiAnimButtonList _AvailableStockButtonsList;

		SoGuiAnimButtonList _PurchasedStockButtonsList;
		SoGuiAnimButtonList _ToBeDeletedStockButtonsList;


		//-----------------------
		// protected functions

		void AddNewButtonForPurchasedHotel( int iHotelId );

		int GetHotelIdFromGuiGuid( guid gGui );
};




