/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"
#include "SoInputDispatcher.h"


USING_NS_CC;


class SoGuiAnimWinRules : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinRules();

		virtual ~SoGuiAnimWinRules();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );
		
		// This is a really hacky way for other menus to know if this window
		// is open.  mdomowicz 2014_02_24
		static bool IsRulesWindowOpen() { return _bIsRulesWindowOpen; }

		std::string GetSpriteFromPageNumber( int iPageNumber );

		#if DCG_IS_TARGET_WIN32
			virtual bool OnMouseMoved( const OIS::MouseEvent &MouseEventArg );
		#endif

		virtual bool OnTouchesMove( const SoCcTouchList* pSoCcTouchList );
		virtual bool OnTouchesDown( const SoCcTouchList* pSoCcTouchList );
		virtual bool OnTouchesUp( const SoCcTouchList* pSoCcTouchList );
		
		virtual bool OnGestureMove( SoGesture* pGesture );

		SoSprite* CreateSprite( const std::string& sPathAndFilename, int iRenderOrder );
		void RemoveAndDestroySprite( SoSprite* pSprite );

		void ZeroUserValues();

		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }


	protected:

		//-----------------------
		// protected variables

		SoClipNode* _pRulebookClipNode;
		SoSprite*   _pRulebookSprite;
		
		float _fScaleMin;
		float _fScaleMax;

		float _fSpeedMax;
		float _fDrag;
		float _fScaleTimer;
		float _fUserScale;

		JpVector2f _vVelocity;
		JpVector2f _vUserOffset;

		CCPoint _vTouchPosPrev;

		int _iRulebookPageNumber;
	
		bool _bMultitouchGestureRecognized;

		guid _gButtonBack;
		guid _gButtonPrevPage;
		guid _gButtonNextPage;

		static bool _bIsRulesWindowOpen;

		//-----------------------
		// protected functions
		void HandleWindowExit();
};




