/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoFontDefs.h"
#include "SoGuiAnimButton.h"
#include "SoGuiAnimComboButton.h"
#include "SoGuiAnimWinSetupPlayers.h"
#include "SoGuiManager.h"
#include "SoGuiMessage.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoGuiWindowShellMain
******************************************************************************/
SoGuiAnimWinSetupPlayers::SoGuiAnimWinSetupPlayers() :
_gButtonNext( 0 ),
_gButtonBack( 0 ),
_pLabelPlayer1( NULL ),
_pLabelPlayer2( NULL ),
_pLabelPlayer3( NULL ),
_pLabelPlayer4( NULL ),
_pLabelPlayer5( NULL ),
_pLabelPlayer6( NULL ),
_pLabelOnError( NULL ),
_gPlayerType1( 0 ),
_gPlayerType2( 0 ),
_gPlayerType3( 0 ),
_gPlayerType4( 0 ),
_gPlayerType5( 0 ),
_gPlayerType6( 0 )
{
}



/******************************************************************************
 FUNCTION:  ~SoGuiWindowShellMain
******************************************************************************/
SoGuiAnimWinSetupPlayers::~SoGuiAnimWinSetupPlayers()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGuiAnimWinSetupPlayers::Init( CCNode* pParentNode, SoGuiManager* pGuiManager )
{
	SoGuiAnimWin::Init( pParentNode, pGuiManager );

	CreateBackgroundSprite( SoUtils::AddRelativePathToTexture( "GuiWindowBgLarge.png" ) );

	SetSpriteAlpha( 0.85f );
	SetPositionToCenterOfParent();
	//SetWidth( 600.0f );
	//SetHeight( 100.0f );

	SetTransitionStyle( SoGuiAnim::TRANSITION_STYLE_POP_UP );	


	_pLabelOnError = CreateBmFontLabel( "", SoFontDefs::GetGuiDefault() );
	_pLabelOnError->setOpacity( 255 );
	_pLabelOnError->setVisible( false );



	SoGuiAnimButton::SetupParams ButtonParams;
	ButtonParams._hSoundEffectOnButtonUp = ( 0x5f1a7f2a /* "SfxSelect2.wav" */ );
	ButtonParams._eButtonDownImageOption = SoGuiAnimButton::BUTTON_DOWN_IMAGE_OPTION_SCALE_THE_UP_IMAGE_DOWN;


	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "GuiButtonNextUp.png" );
	ButtonParams._vRelativePos.Init( 200 * SoUtils::GetiPadRatioX(), -170 * SoUtils::GetiPadRatioY() );
	_gButtonNext = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );


	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "GuiButtonBackUp.png" );
	ButtonParams._vRelativePos.Init( -200 * SoUtils::GetiPadRatioX(), -170 * SoUtils::GetiPadRatioY() );
	_gButtonBack = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );



	_pLabelPlayer1 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer1->setOpacity( 0 );
	_pLabelPlayer1->setString( "Player 1:" );
	_pLabelPlayer1->setAnchorPoint( ccp( 0.5f, 0.5f ) );

	_pLabelPlayer2 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer2->setOpacity( 0 );
	_pLabelPlayer2->setString( "Player 2:" );
	_pLabelPlayer2->setAnchorPoint( ccp( 0.5f, 0.5f ) );

	_pLabelPlayer3 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer3->setOpacity( 0 );
	_pLabelPlayer3->setString( "Player 3:" );
	_pLabelPlayer3->setAnchorPoint( ccp( 0.5f, 0.5f ) );

	_pLabelPlayer4 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer4->setOpacity( 0 );
	_pLabelPlayer4->setString( "Player 4:" );
	_pLabelPlayer4->setAnchorPoint( ccp( 0.5f, 0.5f ) );

	_pLabelPlayer5 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer5->setOpacity( 0 );
	_pLabelPlayer5->setString( "Player 5:" );
	_pLabelPlayer5->setAnchorPoint( ccp( 0.5f, 0.5f ) );

	_pLabelPlayer6 = CreateBmFontLabel( "", SoFontDefs::GetGuiDefaultMedium() );
	_pLabelPlayer6->setOpacity( 0 );
	_pLabelPlayer6->setString( "Player 6:" );
	_pLabelPlayer6->setAnchorPoint( ccp( 0.5f, 0.5f ) );


	SoGuiAnimComboButton::SetupParams ComboButtonParams;
	ComboButtonParams._hSoundEffectOnButtonUp = ( 0x5f1a7f2a /* "SfxSelect2.wav" */ );
	ComboButtonParams._eButtonDownImageOption = SoGuiAnimComboButton::BUTTON_DOWN_IMAGE_OPTION_SCALE_THE_UP_IMAGE_DOWN;

	ComboButtonParams._vRelativePos.Init( -145.0f * SoUtils::GetiPadRatioX(), 150 * SoUtils::GetiPadRatioY() );
	_gPlayerType1 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton1 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType1 );

	ComboButtonParams._vRelativePos.Init( -145.0f * SoUtils::GetiPadRatioX(), 55 * SoUtils::GetiPadRatioY() );
	_gPlayerType2 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton2 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType2 );

	ComboButtonParams._vRelativePos.Init( -145.0f * SoUtils::GetiPadRatioX(), -40 * SoUtils::GetiPadRatioY() );
	_gPlayerType3 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton3 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType3 );

	ComboButtonParams._vRelativePos.Init( 255.0f * SoUtils::GetiPadRatioX(), 150 * SoUtils::GetiPadRatioY() );
	_gPlayerType4 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton4 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType4 );

	ComboButtonParams._vRelativePos.Init( 255.0f * SoUtils::GetiPadRatioX(), 55 * SoUtils::GetiPadRatioY() );
	_gPlayerType5 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton5 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType5 );

	ComboButtonParams._vRelativePos.Init( 255.0f * SoUtils::GetiPadRatioX(), -40 * SoUtils::GetiPadRatioY() );
	_gPlayerType6 = _pGuiManager->CreateAndAddAnimComboButton( ComboButtonParams, this );
	SoGuiAnimComboButton* pComboButton6 = (SoGuiAnimComboButton*)_pGuiManager->GetGuiByGuid( _gPlayerType6 );


	// I attempted to create a more challenging, heuristic based Ai, but I was never able to get
	// it to where it was clearly better than non-heuristic Ai.  I could keep working on it, but
	// it's taking too much of my time, and I must move on.  So I'm leaving the code in place,
	// but disableing it for now.  mdomowicz 2015_11_01
	#ifndef FINAL_BUILD
		#define ALLOW_PLAYER_AI2
	#endif


	pComboButton1->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton1->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif
	pComboButton1->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton1->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton1->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );

	pComboButton2->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton2->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton2->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );
	pComboButton2->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton2->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif

	pComboButton3->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton3->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton3->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );
	pComboButton3->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton3->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif

	pComboButton4->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton4->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton4->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );
	pComboButton4->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton4->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif

	pComboButton5->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton5->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton5->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );
	pComboButton5->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton5->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif

	pComboButton6->SetupAndAddComboButtonValue( JpHash( "AiMedium" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumUp.png" ), "", "" );
	#ifdef ALLOW_PLAYER_AI2
		pComboButton6->SetupAndAddComboButtonValue( JpHash( "AiMediumLevel2" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiMediumLevel2Up.png" ), "", "" );
	#endif
	pComboButton6->SetupAndAddComboButtonValue( JpHash( "None" ), SoUtils::AddRelativePathToTexture( "GuiButtonNoneUp.png" ), "", "" );
	pComboButton6->SetupAndAddComboButtonValue( JpHash( "Human" ), SoUtils::AddRelativePathToTexture( "GuiButtonHumanUp.png" ), "", "" );
	#ifndef FINAL_BUILD
		pComboButton6->SetupAndAddComboButtonValue( JpHash( "AiEasy" ), SoUtils::AddRelativePathToTexture( "GuiButtonAiEasyUp.png" ), "", "" );
	#endif
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGuiAnimWinSetupPlayers::Deinit()
{
	SoGuiAnimWin::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGuiAnimWinSetupPlayers::Update( float dt )
{
	SoGuiAnimWin::Update( dt );

	JpVector2f vLabelPos = _vAbsolutePos;
	vLabelPos.X -= 300.0f * SoUtils::GetiPadRatioX();
	vLabelPos.Y += 150.0f * SoUtils::GetiPadRatioY();

	_pLabelPlayer1->SetPosition( vLabelPos );

	vLabelPos.Y -= 95.0f * SoUtils::GetiPadRatioY();
	_pLabelPlayer2->SetPosition( vLabelPos );

	vLabelPos.Y -= 95.0f * SoUtils::GetiPadRatioY();
	_pLabelPlayer3->SetPosition( vLabelPos );


	vLabelPos = _vAbsolutePos;
	vLabelPos.X += 100.0f * SoUtils::GetiPadRatioX();
	vLabelPos.Y += 150.0f * SoUtils::GetiPadRatioY();

	_pLabelPlayer4->SetPosition( vLabelPos );

	vLabelPos.Y -= 95.0f * SoUtils::GetiPadRatioY();
	_pLabelPlayer5->SetPosition( vLabelPos );

	vLabelPos.Y -= 95.0f * SoUtils::GetiPadRatioY();
	_pLabelPlayer6->SetPosition( vLabelPos );


	vLabelPos = _vAbsolutePos;
	vLabelPos.X -= ( _pLabelOnError->GetCalculatedWidthAllRes() / 2.0f );
	vLabelPos.Y += 215.0f * SoUtils::GetiPadRatioY();
	_pLabelOnError->SetPosition( vLabelPos );

}



/******************************************************************************
 FUNCTION:  HandleMessage
******************************************************************************/
void SoGuiAnimWinSetupPlayers::HandleMessage( SoGuiMessage* pMessage )
{
	switch ( pMessage->GetType() )
	{
		case SoGuiMessage::TYPE_COMBO_BUTTON_ON_UP:
		{
			if ( CountValidPlayers() < 2 )
			{
				_pLabelOnError->setString( "Note: There must be two or more players to start." );
				_pLabelOnError->setVisible( true );
			}
			else if ( CountValidPlayers() == 2 )
			{
				_pLabelOnError->setString( "Note: Achoir is designed for three or more players." );
				_pLabelOnError->setVisible( true );
			}
			else
			{
				_pLabelOnError->setString( "" );
				_pLabelOnError->setVisible( false );
			}

			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_DOWN:
		{
			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP:
		{
			if ( pMessage->GetSendersGuid() == _gButtonNext )
			{

				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "SetupPlayerNextButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}


			if ( pMessage->GetSendersGuid() == _gButtonBack )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "SetupPlayerBackButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}


			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP_TOUCH_OUTSIDE:
		{
			break;
		}
		default:
		{
			SoGuiAnimWin::HandleMessage( pMessage );
			break;
		}
	}
}



/******************************************************************************
 FUNCTION:  GetPlayerTypeComboButtonValue
******************************************************************************/
hash SoGuiAnimWinSetupPlayers::GetPlayerTypeComboButtonValue( int iPlayerNumber )
{
	SoGui* pGui = NULL;

	switch ( iPlayerNumber )
	{
		case 0: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType1 ); break; }
		case 1: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType2 ); break; }
		case 2: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType3 ); break; }
		case 3: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType4 ); break; }
		case 4: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType5 ); break; }
		case 5: { pGui = _pGuiManager->GetGuiByGuid( _gPlayerType6 ); break; }
		default:
			ASSERTF( 0, ( "\nPlayer number out of range." ) );
	}


	SoGuiAnimComboButton* pComboButton = NULL;
	pComboButton = pGui->GetAsComboButton();

	if ( pComboButton )
	{
		SoComboButtonValue* pValue = pComboButton->GetCurrentComboButtonValue();
		if ( pValue )
			return pValue->GetValue();
	}

	return 0;
}



/******************************************************************************
 FUNCTION:  CountValidPlayers
******************************************************************************/
int SoGuiAnimWinSetupPlayers::CountValidPlayers()
{
	int iNumPlayers = 0;

	if ( GetPlayerTypeComboButtonValue( 0 ) != JpHash( "None" ) )
		iNumPlayers ++;
	if ( GetPlayerTypeComboButtonValue( 1 ) != JpHash( "None" ) )
		iNumPlayers ++;
	if ( GetPlayerTypeComboButtonValue( 2 ) != JpHash( "None" ) )
		iNumPlayers ++;
	if ( GetPlayerTypeComboButtonValue( 3 ) != JpHash( "None" ) )
		iNumPlayers ++;
	if ( GetPlayerTypeComboButtonValue( 4 ) != JpHash( "None" ) )
		iNumPlayers ++;
	if ( GetPlayerTypeComboButtonValue( 5 ) != JpHash( "None" ) )
		iNumPlayers ++;

	return iNumPlayers;
}



/******************************************************************************
 FUNCTION:  OnKeypadBackClicked
******************************************************************************/
bool SoGuiAnimWinSetupPlayers::OnKeypadBackClicked()
{
	if ( IsShowing() )
	{
		SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
		GuiMessageForListener.AddHash( JpHash( "SetupPlayerBackButtonPressed" ) );
		SendMessageToListeners( &GuiMessageForListener );
	}

	return true;
}
