/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGuiAnimWin.h"

USING_NS_CC;


class SoGuiAnimWinSetupPlayers : public SoGuiAnimWin
{
	public:

		//-----------------------
		// public functions

		SoGuiAnimWinSetupPlayers();

		virtual ~SoGuiAnimWinSetupPlayers();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		hash GetPlayerTypeComboButtonValue( int iPlayerNumber );

		// SoInputKeypad callbacks
		virtual bool OnKeypadBackClicked();
		virtual bool OnKeypadMenuClicked() { return false; }

	protected:

		//-----------------------
		// protected variables

		SoLabelBmFont* _pLabelPlayer1;
		SoLabelBmFont* _pLabelPlayer2;
		SoLabelBmFont* _pLabelPlayer3;
		SoLabelBmFont* _pLabelPlayer4;
		SoLabelBmFont* _pLabelPlayer5;
		SoLabelBmFont* _pLabelPlayer6;

		SoLabelBmFont* _pLabelOnError;

		guid _gPlayerType1;
		guid _gPlayerType2;
		guid _gPlayerType3;
		guid _gPlayerType4;
		guid _gPlayerType5;
		guid _gPlayerType6;

		guid _gButtonNext;
		guid _gButtonBack;


		//-----------------------
		// protected functions
		int CountValidPlayers();
};




