/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoGuiAnimButton.h"
#include "SoGuiAnimWinStoreBadges.h"
#include "SoGuiManager.h"
#include "SoGuiMessage.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoGuiWindowStoreBadges
******************************************************************************/
SoGuiAnimWinStoreBadges::SoGuiAnimWinStoreBadges() :
_gButtonAppleAppStore( 0 ),
_gButtonGooglePlay( 0 )
{
}



/******************************************************************************
 FUNCTION:  ~SoGuiWindowStoreBadges
******************************************************************************/
SoGuiAnimWinStoreBadges::~SoGuiAnimWinStoreBadges()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoGuiAnimWinStoreBadges::Init( CCNode* pParentNode, SoGuiManager* pGuiManager )
{
	SoGuiAnimWin::Init( pParentNode, pGuiManager );

	//CreateBackgroundSprite( SoUtils::AddRelativePathToTexture( "GuiWindowBgLarge.png" ) );

	SetSpriteAlpha( 0.85f );
	//SetPositionToCenterOfParent();
	SetRelativePos( JpVector2f( 0.0f, -340.0f * SoUtils::GetiPadRatioY() ) );

	//SetWidth( 600.0f );
	//SetHeight( 100.0f );

	SetTransitionStyle( SoGuiAnim::TRANSITION_STYLE_POP_UP );	



	SoGuiAnimButton::SetupParams ButtonParams;
	ButtonParams._hSoundEffectOnButtonUp = ( 0x5f1a7f2a /* "SfxSelect2.wav" */ );
	ButtonParams._eButtonDownImageOption = SoGuiAnimButton::BUTTON_DOWN_IMAGE_OPTION_NO_EFFECT;


	// Achoir is no longer available in the AppStore.  So removing the AppStore badge for now.
	// 2015_11_02
	/*
	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "StoreBadgeAppleAppStore.png" );
	ButtonParams._vRelativePos.Init( -100.0f * SoUtils::GetiPadRatioX(), 0.0f * SoUtils::GetiPadRatioY() );
	_gButtonAppleAppStore = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );
	SoGuiAnimButton* pButtonApple = _pGuiManager->GetGuiAnimButtonByGuid( _gButtonAppleAppStore );
	pButtonApple->SetTransitionStyle( SoGuiAnimButton::TRANSITION_STYLE_NONE );
	*/

	ButtonParams._sPathAndFilenameButtonUp = SoUtils::AddRelativePathToTexture( "StoreBadgeGooglePlay.png" );
	ButtonParams._vRelativePos.Init( 0.0f * SoUtils::GetiPadRatioX(), 0.0f * SoUtils::GetiPadRatioY() );
	_gButtonGooglePlay = _pGuiManager->CreateAndAddAnimButton( ButtonParams, this );
	SoGuiAnimButton* pButtonGoogle = _pGuiManager->GetGuiAnimButtonByGuid( _gButtonGooglePlay );
	pButtonGoogle->SetTransitionStyle( SoGuiAnimButton::TRANSITION_STYLE_NONE );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoGuiAnimWinStoreBadges::Deinit()
{
	SoGuiAnimWin::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoGuiAnimWinStoreBadges::Update( float dt )
{
	SoGuiAnimWin::Update( dt );
}



/******************************************************************************
 FUNCTION:  HandleMessage
******************************************************************************/
void SoGuiAnimWinStoreBadges::HandleMessage( SoGuiMessage* pMessage )
{
	switch ( pMessage->GetType() )
	{
		case SoGuiMessage::TYPE_BUTTON_ON_DOWN:
		{
			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP:
		{
			if ( pMessage->GetSendersGuid() == _gButtonAppleAppStore )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "AppleAppStoreButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}

			if ( pMessage->GetSendersGuid() == _gButtonGooglePlay )
			{
				SoGuiMessage GuiMessageForListener( SoGuiMessage::TYPE_CUSTOM_DATA_FOR_LISTENER );
				GuiMessageForListener.AddHash( JpHash( "GooglePlayButtonPressed" ) );
				SendMessageToListeners( &GuiMessageForListener );
			}

			break;
		}
		case SoGuiMessage::TYPE_BUTTON_ON_UP_TOUCH_OUTSIDE:
		{
			break;
		}
		default:
		{
			SoGuiAnimWin::HandleMessage( pMessage );
			break;
		}
	}
}
