/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoGui.h"
#include "SoHudLog.h"
#include "SoInputVirtualKeyboard.h"

USING_NS_CC;


class SoGuiAnimTextEntry;


class SoGuiChat : public SoGui
{
	public:

		//-----------------------
		// public functions

		SoGuiChat();

		virtual ~SoGuiChat();

		virtual void Init( CCNode* pParentNode, SoGuiManager* pGuiManager );

		virtual void Deinit();

		virtual void Update( float dt );

		virtual void HandleMessage( SoGuiMessage* pMessage );

		void SetMaxOutputLines( int i ) { _HudLog.SetMaxMessagesBeforeFifoRemoval( i ); }

		// SoInputVirtualKeyboard callbacks
		virtual void OnVirtualKeyPressed( char cKey );
		virtual void OnVirtualKeyReleased( char cKey ) {};
		virtual void OnVirtualKeyDeleteBackward() {};


	protected:

		//-----------------------
		// protected variables

		SoHudLog _HudLog;

		SoGuiAnimTextEntry* _pTextEntry;
		guid _gTextEntry;

		SoInputVirtualKeyboardListener< SoGuiChat > _InputVirtualKeyboardListener;
};




