/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;

class SoSprite;


class SoHangdown
{
	public:

		//-----------------------
		// public functions

		SoHangdown();

		virtual ~SoHangdown();

		void Init( CCNode* pParentNode, const char* pacPathAndFilename );

		void Deinit();

		void Update( float dt );

		SoSprite* CreateSprite( CCNode* pParent, const char* pacPathAndFilename );

		JpVector2f GetScale() { return _vScale; }
		void SetScale( JpVector2f val ) { _vScale = val; }
		JpVector2i GetPosition() { return _vPosition; }
		void SetPosition( JpVector2i val ) { _vPosition = val; }


	private:

		//-----------------------
		// private variables

		SoSprite* _pSprite;
		CCNode* _pParentNode;

		JpVector2i _vPosition;
		JpVector2f _vScale;
};



#define SoHangdownList JpList< SoHangdown >



/******************************************************************************
**************************************************  CLASS:  SoHangdownManager
******************************************************************************/
class SoHangdownManager
{
	public:

		//-----------------------
		// public functions
		SoHangdownManager();
		virtual ~SoHangdownManager() {}

		static SoHangdownManager* GetInstance() { return _pInstance; }
		static void CreateInstance();
		static void DeleteInstance();
		static void DeleteAllHangdowns();

		void Update( float dt );

		void CreateHangdowns( char* sParticleName, int iNum = 100 );

		SoHangdownList* GetHangdownList() { return &_pHangdownList; }

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }


	private:

		//-----------------------
		// private

		static SoHangdownManager* _pInstance;

		CCNode* _pParentNode;

		bool _bIsInited;

		SoHangdownList _pHangdownList;
};
















