/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoHotelSet.h"
#include "SoGameBitPlayer.h"
#include "SoConsole.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoHotelSet
******************************************************************************/
SoHotelSet::SoHotelSet()
{
}



/******************************************************************************
 FUNCTION:  ~SoHotelSet
******************************************************************************/
SoHotelSet::~SoHotelSet()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoHotelSet::Init()
{
	for ( int i = 0; i < GAMERULES_NUM_HOTELS; i ++ )
	{
		_aHotels[ i ].Init( NULL );
		_aHotels[ i ].SetHotelId( i );
	}
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoHotelSet::Deinit()
{
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoHotelSet::Update( float dt )
{
}



/******************************************************************************
 FUNCTION:  GetHotelByHotelId
******************************************************************************/
SoGameBitHotel* SoHotelSet::GetHotelByHotelId( int iHotelId )
{
	ASSERTF( iHotelId >=0 && iHotelId < GAMERULES_NUM_HOTELS, ( "\nBad HotelId!" ) );

	if ( iHotelId >=0 && iHotelId < GAMERULES_NUM_HOTELS )
		return &_aHotels[ iHotelId ];

	return NULL;
}



/******************************************************************************
 FUNCTION:  MakeCopy
******************************************************************************/
void SoHotelSet::MakeCopy( SoHotelSet* pSource )
{
	for ( int i = 0; i < GAMERULES_NUM_HOTELS; i ++ )
	{
		_aHotels[ i ].MakeCopy( &pSource->_aHotels[ i ] );
	}
}

