/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "JpString.h"

#include "SoConsole.h"
#include "SoGameBitPlayer.h"
#include "SoHud.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;


SoHud* SoHud::_pInstance = NULL;


/******************************************************************************
 FUNCTION:  SoHud
******************************************************************************/
SoHud::SoHud() :
_pParentNode( NULL )
{
}



/******************************************************************************
 FUNCTION:  ~SoHud
******************************************************************************/
SoHud::~SoHud()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoHud::Init( CCNode* pParentNode )
{
	_pParentNode = pParentNode;

	//_HudButtons.Init( pParentNode );
	//_HudTurns.Init( pParentNode );

	_HudHotelStats.Init( pParentNode );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoHud::Deinit()
{
	//_HudTurns.Deinit();
	//_HudButtons.Deinit();
	_HudHotelStats.Deinit();

	SoHudPlayerGuideList::Iterator PlayerGuideIter( &_PlayerGuideList );
	while ( PlayerGuideIter.Next() )
		delete PlayerGuideIter.GetNodeData();
	_PlayerGuideList.RemoveAll();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoHud::Update( float dt )
{
	//_HudButtons.Update( dt );
	//_HudTurns.Update( dt );
	_HudHotelStats.Update( dt );

	UpdatePlayerGuides( dt );

}



/******************************************************************************
 FUNCTION:  UpdatePlayerGuides
******************************************************************************/
void SoHud::UpdatePlayerGuides( float dt )
{
	SoHudPlayerGuideList::Iterator PlayerGuideIter( &_PlayerGuideList );
	while ( PlayerGuideIter.Next() )
	{
		SoHudPlayerGuide* pGuide = PlayerGuideIter.GetNodeData();

		JpVector2f vGuidePosition = SoHudPlayerGuide::GetHudPositionFromPlayerNumber( pGuide->GetPlayer()->GetPlayerNumber() );
		pGuide->SetPosition( vGuidePosition );

		pGuide->Update( dt );
	}
}



/******************************************************************************
 FUNCTION:  AddPlayerGuide
******************************************************************************/
void SoHud::AddPlayerGuide( SoGameBitPlayer* pPlayer )
{
	SoHudPlayerGuide* pNewGuide = new SoHudPlayerGuide;
	pNewGuide->Init( _pParentNode );
	pNewGuide->SetPlayer( pPlayer );
	_PlayerGuideList.AddLast( pNewGuide );
}



/******************************************************************************
 FUNCTION:  CreateInstance
******************************************************************************/
void SoHud::CreateInstance()
{
	ASSERTF( _pInstance == NULL, ( "\nCan't create more than one instance.  Not allowed." ) );

	if ( !_pInstance )
		_pInstance = new SoHud;
}



/******************************************************************************
 FUNCTION:  DeleteInstance
******************************************************************************/
void SoHud::DeleteInstance()
{
	if ( _pInstance )
	{
		_pInstance->Deinit();

		delete _pInstance;
		_pInstance = NULL;
	}
}


