/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoHudButtons.h"
#include "SoHudHotelStats.h"
#include "SoHudPlayerGuide.h"
#include "SoHudTurns.h"

USING_NS_CC;



class SoHud
{
	public:

		//-----------------------
		// public functions

		SoHud();

		virtual ~SoHud();

		void Init( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }

		SoHudButtons* GetHudButtons() { return &_HudButtons; }

		SoHudTurns* GetHudTurns() { return &_HudTurns; }

		SoHudHotelStats* GetHotelStats() { return &_HudHotelStats; }


		void AddPlayerGuide( SoGameBitPlayer* pPlayer );

		SoHudPlayerGuideList* GetHudPlayerGuideList() { return &_PlayerGuideList; }


		static SoHud* GetInstance() { return _pInstance; }
		static void CreateInstance();
		static void DeleteInstance();

	private:

		//-----------------------
		// private variables
		CCNode* _pParentNode;	

		SoHudButtons _HudButtons;

		SoHudTurns _HudTurns;

		SoHudHotelStats _HudHotelStats;

		SoHudPlayerGuideList _PlayerGuideList;

		static SoHud* _pInstance;


		//-----------------------
		// private functions
		void UpdatePlayerGuides( float dt );
};




