/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


#include "SoInputDispatcher.h"
#include "SoUiButton.h"


USING_NS_CC;


class SoHudButtons
{
	public:
		//-----------------------
		// public enums
		enum STATE
		{
			STATE_HERO_MOVEMENT,
			STATE_TARGETING,
			STATE_LAST
		};


		//-----------------------
		// public functions

		SoHudButtons();

		virtual ~SoHudButtons();

		void Init( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		void AddListener( SoUiButtonManager::Listener* pListener );
		void RemoveListener( SoUiButtonManager::Listener* pListener );

		void OnInput( SoInputDispatcher::InputPacket* pInput );

	private:

		//-----------------------
		// private variables
		CCNode* _pParentNode;

		STATE _eState;

		SoUiButtonManager _UiButtonManager;

		SoUiButton* _pTargetingButton;
		SoUiButton* _pCancelTargetingButton;
		SoUiButton* _pFireButton;
};




