/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpList.h"
#include "SoHudNumber.h"
#include "SoInputDispatcher.h"

USING_NS_CC;


#define SoHudPlayerGuideList JpList< SoHudPlayerGuide >


class SoGameBitPlayer;
class SoSprite;


class SoHudPlayerGuide
{
	public:

		//-----------------------
		// public functions

		SoHudPlayerGuide();

		virtual ~SoHudPlayerGuide();

		void Init( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		const JpVector2f& GetPosition() { return _vPosition; }
		void SetPosition( const JpVector2f& v ) { _vPosition = v; }

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }

		SoGameBitPlayer* GetPlayer() { return _pPlayer; }
		void SetPlayer( SoGameBitPlayer* p ) { _pPlayer = p; }

		void OnInput( SoInputDispatcher::InputPacket* pInput );

		virtual bool IsPositionInside( const JpVector2f& vScreenPos );

		static JpVector2f GetHudPositionFromPlayerNumber( int iPlayerNumber );

	private:

		//-----------------------
		// private variables
		CCNode* _pParentNode;

		JpVector2f _vPosition;

		SoSprite* _pPortraitSprite;

		SoSprite* _pTrophySprite;

		SoHudNumber _HudNumberMoney;
	
		SoGameBitPlayer* _pPlayer;

		SoLabelBmFont* _pPlayerLabel;
		JpVector2f _vPlayerLabelOffset;

		SoLabelBmFont* _pDollarSignLabel;

		int _iTouchState;

		float _fTimer;
		float _fOffsetY;
		int _iAnimState;

		//-----------------------
		// private functions
		void CreateAssets();
		bool IsPositionInsideSprite( const JpVector2f& vScreenPos, SoSprite* pSprite );
};




