/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "JpString.h"

#include "SoActor.h"
#include "SoFontDefs.h"
#include "SoHudTurns.h"
#include "SoLabelBmFont.h"
#include "SoSprite.h"
#include "SoUtils.h"

#include "mmgrChooser.h"


USING_NS_CC;



/******************************************************************************
 FUNCTION:  SoHudTurns
******************************************************************************/
SoHudTurns::SoHudTurns() :
_pParentNode( NULL ),
_vPosition( 0.0f, 0.0f )
{
}



/******************************************************************************
 FUNCTION:  ~SoHudTurns
******************************************************************************/
SoHudTurns::~SoHudTurns()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoHudTurns::Init( CCNode* pParentNode )
{
	_pParentNode = pParentNode;

	float fX = 40.0f * SoUtils::GetiPadRatioX();
	float fY = 765.0f * SoUtils::GetiPadRatioY();
	_vPosition.Init( fX, fY );

	_HudNumber.Init( pParentNode, 6, SoFontDefs::GetHudTurns() );
	_HudNumber.SetPosition( _vPosition );
	_HudNumber.SetCurrentNumber( 1 );
	_HudNumber.SetSpacing( 10.0f );

	_pIconSprite = SoUtils::CreateSprite( _pParentNode, SoUtils::AddRelativePathToTexture( "HudTurnsIcon.png" ) );
	fX = 20.0f * SoUtils::GetiPadRatioX();
	fY = 750.0f * SoUtils::GetiPadRatioY();
	_pIconSprite->SetPosition( JpVector2f( fX, fY ) );
	_pIconSprite->setVisible( false );
	SoUtils::SetRenderZOrder( _pParentNode, _pIconSprite, BASE_RENDER_ORDER_HUD );
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoHudTurns::Deinit()
{
	_HudNumber.Deinit();

	SoUtils::RemoveAndDestroyNode( _pParentNode, _pIconSprite );
	_pIconSprite = NULL;
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoHudTurns::Update( float dt )
{
	_pIconSprite->setVisible( true );
	_HudNumber.Update( dt );
	_HudNumber.SetPosition( _vPosition );
}



/******************************************************************************
 FUNCTION:  SetGoldAmount
******************************************************************************/
void SoHudTurns::SetAmount( int i )
{
	_iAmount = i;
	_HudNumber.SetTargetNumber( i );
}

