/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"

#if DCG_IS_TARGET_WIN32

#include "cocos2d.h"
#include "OIS.h"


USING_NS_CC;


#define DCG_MAX_OIS_JOYSTICKS 4


class SoInputOisManager
{
	public:

		//-----------------------
		// public functions

		SoInputOisManager();

		virtual ~SoInputOisManager();

		void Init();

		void Deinit();

		void Update( float dt );

		void SetKeyboardListener( OIS::KeyListener* pKeyboardListener );
		void SetMouseListener( OIS::MouseListener* pMouseListener );

		OIS::Keyboard* GetOisKeyboard() { return _pOisKeyboard; }
		OIS::Mouse* GetOisMouse() { return _pOisMouse; }

		static char GetCharacterFromKeyCode( OIS::KeyCode eKeyCode );

		static SoInputOisManager* GetInstance() { return _pInstance; }
		static void CreateInstance();
		static void DeleteInstance();


	private:

		//-----------------------
		// private variables

		static SoInputOisManager* _pInstance;

		static char* _pDeviceType[ 6 ];

		OIS::InputManager* _pOisInputManager;
		OIS::Keyboard* _pOisKeyboard;
		OIS::Mouse* _pOisMouse;
		OIS::JoyStick* _pOisJoysticks[ DCG_MAX_OIS_JOYSTICKS ];
};

#endif // DCG_IS_TARGET_WIN32



