/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "SoLabelBmFont.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoLabelBmFont
******************************************************************************/
SoLabelBmFont::SoLabelBmFont()
{
}



/******************************************************************************
 FUNCTION:  ~SoLabelBmFont
******************************************************************************/
SoLabelBmFont::~SoLabelBmFont()
{
}



/******************************************************************************
 FUNCTION:  GetCalculatedWidth
******************************************************************************/
float SoLabelBmFont::GetCalculatedWidth()
{ 
	// Sometimes, even if the string is empty, getContentSize.width will
	// be a non-zero value.  This seems to occur when the string is made empty
	// after it once had a value, and the size seems to be the size of the
	// previous string.  As far as I can tell, that's undesirable behavior,
	// and hence the check here.  mdomowicz 2013_09_23

	if ( strlen( getString() ) > 0 )
		return getContentSize().width; 

	return 0.0f;
}



/******************************************************************************
 FUNCTION:  create
 NOTE:      copied from base class
******************************************************************************/
SoLabelBmFont * SoLabelBmFont::create()
{
    SoLabelBmFont * pRet = new SoLabelBmFont();
    if (pRet && pRet->init())
    {
        pRet->autorelease();
        return pRet;
    }
    CC_SAFE_DELETE(pRet);
    return NULL;
}



/******************************************************************************
 FUNCTION:  labelWithString
 NOTE:      copied from base class
******************************************************************************/
SoLabelBmFont *SoLabelBmFont::labelWithString(const char *str, const char *fntFile, float width/* = kCCLabelAutomaticWidth*/, CCTextAlignment alignment/* = kCCTextAlignmentLeft*/, CCPoint imageOffset/* = CCPointZero*/)
{
    return SoLabelBmFont::create(str, fntFile, width, alignment, imageOffset);
}



/******************************************************************************
 FUNCTION:  create
 NOTE:      copied from base class
******************************************************************************/
SoLabelBmFont *SoLabelBmFont::create(const char *str, const char *fntFile, float width/* = kCCLabelAutomaticWidth*/, CCTextAlignment alignment/* = kCCTextAlignmentLeft*/, CCPoint imageOffset/* = CCPointZero*/)
{
    SoLabelBmFont *pRet = new SoLabelBmFont();
    if(pRet && pRet->initWithString(str, fntFile, width, alignment, imageOffset))
    {
        pRet->autorelease();
        return pRet;
    }
    CC_SAFE_DELETE(pRet);
    return NULL;
}
