/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once



#include "stdafx.h"
#include "cocos2d.h"

#include "SoUtils.h"

#define SoLabelBmFontList JpList< SoLabelBmFont >

USING_NS_CC;


class SoLabelBmFont : public CCLabelBMFont
{
	public:

		//-----------------------
		// public functions

		SoLabelBmFont();

		virtual ~SoLabelBmFont();

		void SetPosition( const JpVector2f& v ) { setPosition( v.X, v.Y ); }
		JpVector2f GetPosition() { return JpVector2f( getPositionX(), getPositionY() ); }

		// Get the height of a single line.  Useful for calculating how much to 
		// to move up or down when dealing with multi line output, such as a log
		// or a console.
		float GetLineHeight() { return m_pConfiguration->m_nCommonHeight; }

		// Not entirely necessary, but here to remind that the content size is actually
		// updated to match the string.  For example, if a label's width is too short for
		// the text it must display, then a carriage return occurs, and the content height
		// is set to match this new, larger, height.
		// mdomowicz 2012_09_18
		float GetCalculatedWidth();
		float GetCalculatedHeight() { return getContentSize().height; }

		float GetCalculatedWidthAllRes() { return GetCalculatedWidth() * SoUtils::GetiPadRatioX(); } 
		float GetCalculatedHeightAllRes() { return GetCalculatedHeight() * SoUtils::GetiPadRatioY(); }

		// Get the render string. This string has been wrapped to fit with the width of the label.
		const unsigned short* GetRenderString() { return m_sString; }


		// These functions are copied from the base class
		CC_DEPRECATED_ATTRIBUTE static SoLabelBmFont * labelWithString(const char *str, const char *fntFile, float width = kCCLabelAutomaticWidth, CCTextAlignment alignment = kCCTextAlignmentLeft, CCPoint imageOffset = CCPointZero);
		static SoLabelBmFont * create(const char *str, const char *fntFile, float width = kCCLabelAutomaticWidth, CCTextAlignment alignment = kCCTextAlignmentLeft, CCPoint imageOffset = CCPointZero);
		static SoLabelBmFont * create();

	private:

		//-----------------------
		// private variables
};




