/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"


#include "SoLoadScreen.h"
#include "SoUtils.h"


#include "mmgrChooser.h"



SoLoadScreen* SoLoadScreen::_pInstance = NULL;
SoLoadScreenLayer* SoLoadScreen::_pLayer = NULL;



/******************************************************************************
 FUNCTION:  SoLoadScreen
******************************************************************************/
SoLoadScreen::SoLoadScreen()
{
}



/******************************************************************************
 FUNCTION:  SoLoadScreen
******************************************************************************/
SoLoadScreen::~SoLoadScreen()
{
}


/******************************************************************************
 FUNCTION:  CreateInstance
******************************************************************************/
void SoLoadScreen::CreateInstance( CCScene* pScene )
{
	ASSERTF( !_pInstance, ( "\nCan't create a second static instance of this class." ) )
	if ( !_pInstance )
	{
		_pInstance = new SoLoadScreen;
		
		if ( !_pLayer )
		{
			_pLayer = SoLoadScreenLayer::create();
			_pLayer->retain();
			pScene->addChild(_pLayer);
		}
	}
}



/******************************************************************************
 FUNCTION:  DeleteInstance
******************************************************************************/
void SoLoadScreen::DeleteInstance()
{
	if ( _pInstance )
	{
		if ( _pLayer )
		{
			_pLayer->removeFromParentAndCleanup( true );
			_pLayer->release();
			_pLayer = NULL;
		}

		delete _pInstance;
		_pInstance = NULL;
	}
}



/******************************************************************************
 FUNCTION:  GetLoadScreen
******************************************************************************/
SoSprite* SoLoadScreen::GetLoadScreen()
{
	if ( _pLayer )
		return _pLayer->GetLoadScreen();
	return NULL;
}




/******************************************************************************
 FUNCTION:  GetScreenFader
******************************************************************************/
SoScreenFader* SoLoadScreen::GetScreenFader()
{
	if ( _pLayer )
		return _pLayer->GetScreenFader();
	return NULL;
}










/******************************************************************************
 FUNCTION:  SoLoadScreenLayer
******************************************************************************/
SoLoadScreenLayer::SoLoadScreenLayer() :
_pScreenFader( NULL ),
_pLoadScreenSprite( NULL ),
_eCurrentState( STATE_LAST ),
_fTimer( NULL )
{
}



/******************************************************************************
 FUNCTION:  ~SoLoadScreenLayer
******************************************************************************/
SoLoadScreenLayer::~SoLoadScreenLayer()
{
}


/******************************************************************************
 FUNCTION:  init
******************************************************************************/
bool SoLoadScreenLayer::init()
{
	if ( CCLayerColor::initWithColor( ccc4(0,0,0,255) ) )
	{
		CCDirector::sharedDirector()->setProjection(kCCDirectorProjection2D);
		CCSize size = CCDirector::sharedDirector()->getWinSize();



		//--------------------
		// Load screen
/*
		_pLoadScreenSprite = SoSprite::CreateScaledToDevice( SoUtils::AddRelativePathToTexture( "ImgLoading.png" ) );

		// Place and scale the image so that it's stretched to fill the entire screen
		_pLoadScreenSprite->setPosition( ccp(size.width/2, size.height/2) );
		_pLoadScreenSprite->setScaleX( size.width / _pLoadScreenSprite->getContentSize().width );
		_pLoadScreenSprite->setScaleY( size.height / _pLoadScreenSprite->getContentSize().height );
		_pLoadScreenSprite->setVisible( false );

		addChild( _pLoadScreenSprite, BASE_RENDER_ORDER_SHELL );

*/
		int iRenderOrder = 0;
// 		_pScreenFader = SoScreenFader::create();
// 		_pScreenFader->retain();
// 		_pScreenFader->Setup( this, iRenderOrder );
// 		_pScreenFader->SetFadeSpeed( 1.0f );
// 		_pScreenFader->SetFadeDirection( SoScreenFader::FADE_DIRECTION_OPAQUE_TO_TRANSPARENT );
// 		_pScreenFader->BeginFade();

		scheduleUpdate();
		setTouchEnabled( true );

		_fTimer = 0.0f;
		_eCurrentState = STATE_LAST;

		return true;
	}


	return false;
}





/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoLoadScreenLayer::Deinit()
{
	if ( _pScreenFader )
	{
		_pScreenFader->Deinit();
		_pScreenFader->release();
		_pScreenFader = NULL;
	}

	removeAllChildrenWithCleanup( DCG_CLEANUP_ALL_RUNNING_ACTIONS );
}



/******************************************************************************
 FUNCTION:  update
******************************************************************************/
void SoLoadScreenLayer::update( float dt )
{
	_fTimer += dt;

	if ( _pScreenFader )
		_pScreenFader->Update( dt );

	switch ( _eCurrentState )
	{

		case STATE_DONE:
		case STATE_LAST:
		default:
			break;
	}
}



/******************************************************************************
 FUNCTION:  ccTouchesEnded
******************************************************************************/
void SoLoadScreenLayer::ccTouchesEnded(CCSet *pTouches, CCEvent *pEvent)
{
}



/******************************************************************************
 FUNCTION:  ccTouchesCancelled
******************************************************************************/
void SoLoadScreenLayer::ccTouchesCancelled(CCSet *pTouches, CCEvent *pEvent)
{
	ccTouchesEnded(pTouches, pEvent);
}



/******************************************************************************
 FUNCTION:  create
******************************************************************************/
SoLoadScreenLayer* SoLoadScreenLayer::create()
{
	SoLoadScreenLayer* pRet = new SoLoadScreenLayer();
	if ( pRet && pRet->init() )
	{
		pRet->autorelease();
		return pRet;
	}
	else
	{
		delete pRet;
		pRet = NULL;
		return NULL;
	}
}


















