
/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoHudNumber.h"
#include "SoScreenFader.h"
#include "SoSprite.h"


USING_NS_CC;


class SoLoadScreenLayer;


class SoLoadScreen
{
	public:

		//-----------------------
		// public functions

		SoLoadScreen();

		virtual ~SoLoadScreen();


		static void CreateInstance( CCScene* pScene );
		static void DeleteInstance();
		static SoLoadScreen* GetInstance() { return _pInstance; }
		static SoSprite* GetLoadScreen();
		static SoScreenFader* GetScreenFader();
		static SoLoadScreenLayer* GetLayer() { return _pLayer; }



	private:

		//-----------------------
		// private variables

		static SoLoadScreen* _pInstance;
		static SoLoadScreenLayer* _pLayer;
};








class SoLoadScreenLayer : public cocos2d::CCLayerColor
{
public:

	//-----------------------
	// public enums
	enum STATE
	{
		STATE_DONE,
		STATE_LAST
	};

	//-----------------------
	// public functions

	SoLoadScreenLayer();
	virtual ~SoLoadScreenLayer();

	virtual bool init();
	void Deinit();

	virtual void update( float dt );

	LAYER_NODE_FUNC( SoLoadScreenLayer );

	bool IsDone() { return _eCurrentState == STATE_DONE; }

	SoSprite* GetLoadScreen() { return _pLoadScreenSprite; }
	SoScreenFader* GetScreenFader() { return _pScreenFader; }

	virtual void ccTouchesBegan(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
	virtual void ccTouchesMoved(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent) {};
	virtual void ccTouchesEnded(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);
	virtual void ccTouchesCancelled(cocos2d::CCSet *pTouches, cocos2d::CCEvent *pEvent);


	static SoLoadScreenLayer* create();


private:

	//-----------------------
	// private variables
	float _fTimer;

 	SoScreenFader* _pScreenFader;

	SoSprite* _pLoadScreenSprite;

	STATE _eCurrentState;
};






