/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "JpDebug.h"
#include "SoGameGlobals.h"
#include "SoNetworkComms.h"

#include "mmgrChooser.h"


USING_NS_CC;


/******************************************************************************
 FUNCTION:  SoNetworkComms
******************************************************************************/
SoNetworkComms::SoNetworkComms()
{
}



/******************************************************************************
 FUNCTION:  ~SoNetworkComms
******************************************************************************/
SoNetworkComms::~SoNetworkComms()
{
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoNetworkComms::Init()
{
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoNetworkComms::Deinit()
{
	SoGameMessageList::Iterator Iter1( &_MessagesForServers );
	while ( Iter1.Next() )
		delete Iter1.GetNodeData();
	_MessagesForServers.RemoveAll();
	
	SoGameMessageList::Iterator Iter2( &_MessagesForClients );
	while ( Iter2.Next() )
		delete Iter2.GetNodeData();
	_MessagesForClients.RemoveAll();

	SoNetworkChatTextList::Iterator Iter3( &_IncomingChatText );
	while ( Iter3.Next() )
		delete Iter3.GetNodeData();
	_IncomingChatText.RemoveAll();

	SoNetworkChatTextList::Iterator Iter4( &_OutgoingChatText );
	while ( Iter4.Next() )
		delete Iter4.GetNodeData();
	_OutgoingChatText.RemoveAll();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoNetworkComms::Update( float dt )
{
}



/******************************************************************************
 FUNCTION:  RequestNewClientId
******************************************************************************/
hash SoNetworkComms::RequestNewClientId()
{
	// Note - eventually we'll need something much more elaborate than this
	// mainly to prevent id collisions.  But for now this is fine.
	return JpRandom::G.GetInt();
}



/******************************************************************************
 FUNCTION:  FindAvailableServer
******************************************************************************/
hash SoNetworkComms::FindAvailableServer()
{
	return 0;
}




/******************************************************************************
 FUNCTION:  SendMessageToServer
******************************************************************************/
void SoNetworkComms::SendMessageToServer( SoGameMessage& Message )
{
}



/******************************************************************************
 FUNCTION:  SendMessageToClient
******************************************************************************/
void SoNetworkComms::SendMessageToClient( SoGameMessage& Message )
{
}



/******************************************************************************
 FUNCTION:  GetNextMessageForServer
******************************************************************************/
SoGameMessage* SoNetworkComms::GetNextMessageForServer( hash hServerId )
{
	return NULL;
}



/******************************************************************************
 FUNCTION:  RemoveAndDeleteMessageForServer
******************************************************************************/
void SoNetworkComms::RemoveAndDeleteMessageForServer( SoGameMessage* p )
{
}




/******************************************************************************
 FUNCTION:  GetNextMessageForClient
******************************************************************************/
SoGameMessage* SoNetworkComms::GetNextMessageForClient( hash hServerId, hash hClientId )
{
	return NULL;
}



/******************************************************************************
 FUNCTION:  RemoveAndDeleteMessageForClient
******************************************************************************/
void SoNetworkComms::RemoveAndDeleteMessageForClient( SoGameMessage* p )
{
}



/******************************************************************************
 FUNCTION:  SendChatText
******************************************************************************/
void SoNetworkComms::SendChatText( const std::string& s )
{
	SoNetworkChatText* pNewChatText = new SoNetworkChatText;
	pNewChatText->SetText( SoNetworkChatText::SqlSanitizeString( s ) );
	_OutgoingChatText.AddLast( pNewChatText );
}



/******************************************************************************
 FUNCTION:  GetNextChatText
******************************************************************************/
SoNetworkChatText* SoNetworkComms::GetNextChatText()
{
	SoNetworkChatTextList::Node* pFirstNode = _IncomingChatText.GetFirst();
	return pFirstNode->GetData();
}



/******************************************************************************
 FUNCTION:  RemoveAndDeleteChatText
******************************************************************************/
void SoNetworkComms::RemoveAndDeleteChatText( SoNetworkChatText* p )
{
	_IncomingChatText.Remove( p );
	delete p;
}
