/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpHashTable.h"
#include "JpList.h"
#include "SoGameMessage.h"
#include "SoNetworkChatText.h"

USING_NS_CC;

class SoNetworkCommsOffline;
class SoNetworkCommsOnline;

class SoNetworkComms
{
	public:

		//-----------------------
		// public functions

		SoNetworkComms();

		virtual ~SoNetworkComms();

		virtual void Init();

		virtual void Deinit();

		virtual void Update( float dt );

		virtual SoNetworkCommsOffline* GetAsNetworkCommsOffline() { return NULL; }
		virtual SoNetworkCommsOnline* GetAsNetworkCommsOnline() { return NULL; }

		virtual hash RequestNewClientId();
		virtual hash FindAvailableServer();
		virtual void SendMessageToServer( SoGameMessage& Message );
		virtual void SendMessageToClient( SoGameMessage& Message );


		virtual SoGameMessage* GetNextMessageForServer( hash hServerId );
		virtual void RemoveAndDeleteMessageForServer( SoGameMessage* p );

		virtual SoGameMessage* GetNextMessageForClient( hash hServerId, hash hClientId );
		virtual void RemoveAndDeleteMessageForClient( SoGameMessage* p );


		virtual void SendChatText( const std::string& s );
		virtual SoNetworkChatText* GetNextChatText();
		virtual void RemoveAndDeleteChatText( SoNetworkChatText* p );

		virtual void TellWebServerGameHasStarted() {};

	protected:

		//-----------------------
		// protected variables

		SoGameMessageList _MessagesForServers;
		SoGameMessageList _MessagesForClients;

		SoNetworkChatTextList _IncomingChatText;
		SoNetworkChatTextList _OutgoingChatText;
};




