/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include "JpDebug.h"
#include "SoGameGlobals.h"
#include "SoNetworkCommsOffline.h"

#include "mmgrChooser.h"


USING_NS_CC;



/******************************************************************************
 FUNCTION:  SoNetworkCommsOffline
******************************************************************************/
SoNetworkCommsOffline::SoNetworkCommsOffline()
{
	Init();
}



/******************************************************************************
 FUNCTION:  ~SoNetworkCommsOffline
******************************************************************************/
SoNetworkCommsOffline::~SoNetworkCommsOffline()
{
	Deinit();
}



/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void SoNetworkCommsOffline::Init()
{
	SoNetworkComms::Init();
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void SoNetworkCommsOffline::Deinit()
{
	SoNetworkComms::Deinit();
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void SoNetworkCommsOffline::Update( float dt )
{
	SoNetworkComms::Update( dt );
}



/******************************************************************************
 FUNCTION:  FindAvailableServer
******************************************************************************/
hash SoNetworkCommsOffline::FindAvailableServer()
{
	if ( SoGameGlobals::GetServer() )
		return SoGameGlobals::GetServer()->GetServerId();

	return 0;
}




/******************************************************************************
 FUNCTION:  SendMessageToServer
******************************************************************************/
void SoNetworkCommsOffline::SendMessageToServer( SoGameMessage& Message )
{
	SoGameMessage* pNewMessage = new SoGameMessage;
	pNewMessage->CopyMessage( Message );

	_MessagesForServers.AddLast( pNewMessage );
}



/******************************************************************************
 FUNCTION:  SendMessageToClient
******************************************************************************/
void SoNetworkCommsOffline::SendMessageToClient( SoGameMessage& Message )
{
	SoGameMessage* pNewMessage = new SoGameMessage;
	pNewMessage->CopyMessage( Message );

	_MessagesForClients.AddLast( pNewMessage );
}



/******************************************************************************
 FUNCTION:  GetNextMessageForServer
******************************************************************************/
SoGameMessage* SoNetworkCommsOffline::GetNextMessageForServer( hash hServerId )
{
	SoGameMessageList::Iterator Iter( &_MessagesForServers );
	while ( Iter.Next() )
	{
		SoGameMessage* pMessage = Iter.GetNodeData();
		if ( pMessage->GetServerId() == hServerId )
			return pMessage;
	}

	return NULL;
}



/******************************************************************************
 FUNCTION:  RemoveAndDeleteMessageForServer
******************************************************************************/
void SoNetworkCommsOffline::RemoveAndDeleteMessageForServer( SoGameMessage* p )
{
	_MessagesForServers.Remove( p );
	delete p;
}




/******************************************************************************
 FUNCTION:  GetNextMessageForClient
******************************************************************************/
SoGameMessage* SoNetworkCommsOffline::GetNextMessageForClient( hash hServerId, hash hClientId )
{
	SoGameMessageList::Iterator Iter( &_MessagesForClients );
	while ( Iter.Next() )
	{
		SoGameMessage* pMessage = Iter.GetNodeData();
		if ( pMessage->GetServerId() == hServerId )
		{
			if ( pMessage->GetClientId() == hClientId )
				return pMessage;
		}
	}

	return NULL;
}



/******************************************************************************
 FUNCTION:  RemoveAndDeleteMessageForClient
******************************************************************************/
void SoNetworkCommsOffline::RemoveAndDeleteMessageForClient( SoGameMessage* p )
{
	_MessagesForClients.Remove( p );
	delete p;
}




