/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpHashTable.h"
#include "JpList.h"

#include "SoCurl.h"
#include "SoGameMessage.h"
#include "SoNetworkComms.h"


USING_NS_CC;

class SoGameClient;

class SoNetworkCommsOnline : public SoNetworkComms
{
	public:

		//-----------------------
		// public functions

		SoNetworkCommsOnline();

		virtual ~SoNetworkCommsOnline();

		virtual void Init();

		virtual void Deinit();

		virtual void Update( float dt );

		virtual SoNetworkCommsOnline* GetAsNetworkCommsOnline() { return this; }

		virtual hash FindAvailableServer();
		virtual void SendMessageToServer( SoGameMessage& Message );
		virtual void SendMessageToClient( SoGameMessage& Message );


		virtual SoGameMessage* GetNextMessageForServer( hash hServerId );
		virtual void RemoveAndDeleteMessageForServer( SoGameMessage* p );

		virtual SoGameMessage* GetNextMessageForClient( hash hServerId, hash hClientId );
		virtual void RemoveAndDeleteMessageForClient( SoGameMessage* p );

		virtual void TellWebServerGameHasStarted() { _bTellWebServerGameHasStarted = true; }
		
		// SoCurl callback
		virtual void OnCurlDataReceived( const std::string& sData );


	protected:

		//-----------------------
		// protected variables
		SoCurlListener< SoNetworkCommsOnline > _CurlListener;

		SoGameMessageList _OutgoingMessagesForServers;
		SoGameMessageList _OutgoingMessagesForClients;

		int _iUpdateState;
		bool _bPrintNetworkMessages;

		bool _bTellWebServerGameHasStarted;
		bool _bGotWebServersOnConnectMessage;

		float _fKeepAliveTestTimer;

		//-----------------------
		// protected functions

		void AppendCurlDataFromMessage( std::string* pResultString, SoGameMessage& Message );
		void AppendCurlDataFromChatText( std::string* pResultString, SoNetworkChatText* pChatText );

		std::string ExtractMessageTypeFromCurlData( const std::string& sData );
		std::string ExtractMessageDataFromCurlData( const std::string& sData );

		bool ParseChatTextFromCurlData( SoNetworkChatText* pChatTextResult, const std::string& sData );
		bool ParseMessageFromCurlData( SoGameMessage* pMessageResult, const std::string& sData );

		SoGameClient* GetClient();

};




