/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "stdafx.h"

#include "JpString.h"
#include "NeCsvIn.h"
#include "NeCsvOut.h"

USING_NS_CC;


class NeCsvIn;


class SoSaveSystem
{
	public:

		//-----------------------
		// public functions
		SoSaveSystem() { Init(); }
		~SoSaveSystem() {}

		void Init();

		void Save();
		void LoadLevel( int iLevelId );
		void LoadGame();


		char* GetSavePath() { return _acSavePath; }
		void SetSavePath( char* pacPathWithoutEndBackslash ) { JpUtils::CopyString( _acSavePath, pacPathWithoutEndBackslash, 128 ); }

		char* ConstructPathAndFileName( char* pacFileNameNoExt, int iLevelId );

		int GetCurrentLevelId() { return _iCurrentLevelId; }
		void SetCurrentLevelId( int i ) { _iCurrentLevelId = i; }

		NeCsvOut* GetSharedCsvWriter() { return &_SharedCsvWriter; }
		NeCsvIn* GetSharedCsvReader() { return &_SharedCsvReader; }

		static SoSaveSystem* GetInstance() { return _pInstance; }
		static void CreateInstance();
		static void DeleteInstance();

		int GetSharedCsvReaderIndex() { return _iSharedCsvReaderIndex; }
		void SetSharedCsvReaderIndex( int i ) { _iSharedCsvReaderIndex = i; }
		int IncrementSharedCsvReaderIndex()
		{
			_iSharedCsvReaderIndex ++;
			return _iSharedCsvReaderIndex;
		}

		bool DoesSaveDataExistForLastDungeon();

	private:

		//-----------------------
		// private variables
		static SoSaveSystem* _pInstance;

		char _acSavePath[ 128 ];
		char _acConstructedPathAndFilename[ 256 ];
		int _iCurrentLevelId;

		NeCsvOut _SharedCsvWriter;
		NeCsvIn _SharedCsvReader;
		int _iSharedCsvReaderIndex;


		//-----------------------
		// private functions
		void GenerateSavePath();
};



