/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


USING_NS_CC;


class SoScreenFader : public CCNode
{
	public:

		enum STATE
		{
			STATE_WAIT,
			STATE_FADE,
			STATE_DONE,
			STATE_LAST
		};

		enum FADE_DIRECTION
		{
			FADE_DIRECTION_TRANSPARENT_TO_OPAQUE,
			FADE_DIRECTION_OPAQUE_TO_TRANSPARENT,
			FADE_DIRECTION_LAST
		};


		//-----------------------
		// public functions

		SoScreenFader();

		virtual ~SoScreenFader();

		virtual bool init() { return true; }
		void Setup( CCNode* pParentNode, int iRenderOrder );
		void Deinit();
		void Update( float dt );

		virtual void draw();

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }

		const ccColor3B& GetColor() { return _Color; }
		void SetColor( const ccColor3B& Color ) { _Color = Color; }

		void SetFadeDirection( FADE_DIRECTION e ) { _eFadeDirection = e; }
		FADE_DIRECTION GetFadeDirection() { return _eFadeDirection; }

		void SetFadeSpeed( float f ) { _fFadeSpeed = f; }

		void BeginFade();

		bool IsDone() { return _eCurrentState == STATE_DONE; }

		static SoScreenFader* create();

	private:

		//-----------------------
		// private variables
		STATE _eCurrentState;

		CCNode* _pParentNode;
		float _fTimer;

		ccColor3B _Color;
		FADE_DIRECTION _eFadeDirection;
		float _fFadeSpeed;

		float _fAlpha;
};




