/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoSpriteAnim.h"

USING_NS_CC;


class SoSpriteAnimSet
{
	public:

		//-----------------------
		// public functions

		SoSpriteAnimSet();

		virtual ~SoSpriteAnimSet();

		void Init( CCNode* pParentNode );

		void Deinit();

		void Update( float dt );

		void Play( const char* pacAnimTableKey );
		void PlayReverse( const char* pacAnimTableKey );

		void SetPosition( const JpVector2f& v );

		void SetScale( float f );
		void SetScaleX( float f );
		void SetScaleY( float f );

		float GetScaleX() { return _vScale.X; }
		float GetScaleY() { return _vScale.Y; }

		float GetOpacity() { return _fOpacity; }
		void SetOpacity( float fPercent );

		void SetRenderZOrder( int iZWhereLargerMeansCloser );

		bool GetIsFlippedInDirX() { return _bIsFlippedInDirX; }
		void SetFlipInDirX( bool b );

		bool GetIsFlippedInDirY() { return _bIsFlippedInDirY; }
		void SetFlipInDirY( bool b );

		void StopCurrentAnimation();

		bool CurrentAnimIsStopped();
		bool CurrentAnimHasCompleted();

		void LoadAnimFilesByCsv( const char* pacCsvPathAndFilename );

		SoSpriteAnim* GetCurrentAnim() { return  _pCurrentAnim; }


	private:

		//-----------------------
		// private variables
		CCNode* _pParentNode;

		SoSpriteAnim* _pCurrentAnim;

		SoSpriteAnimTable64 _SpriteAnimTable;

		int _iRenderZOrder;

		JpVector2f _vScale;
		JpVector2f _vPosition;

		float _fOpacity;
	
		bool _bIsFlippedInDirX;
		bool _bIsFlippedInDirY;
};




