/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "JpVector.h"

#include "SoActor.h"

USING_NS_CC;



class SoTextureUtils
{
	public:

		static void ResetSharedTextures();

		static CCImage* ScaleImage( const char *pszSpriteFrameName, float fScale );
		static CCImage* ScaleImageBicubic( const char *pszSpriteFrameName, float fScale );

		static CCTexture2D* AddUiImageScaled( const char *pszSpriteFrameName, float fScale );

		static float GetTextureScaler() { return _fTextureScaler; }
		static void  SetTextureScaler( float f ) { _fTextureScaler = f; }
	
		static int  GetTextureFilter() { return _iTextureFilter; }
		static void SetTextureFilter( int i ) { _iTextureFilter = i; }
		
		static unsigned char GetPixelComponent( unsigned char* pData, int iX, int iY, int iSourceWidth, int iSourceHeight, int iChannel, int iNumChannels = 4 );


	private:

		static float _fTextureScaler;
		static int   _iTextureFilter;
};