/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"

#include "SoHudNumber.h"

USING_NS_CC;

class SoLabelBmFont;


class SoWatermark
{
	public:

		//-----------------------
		// public functions

		SoWatermark();

		virtual ~SoWatermark();

		virtual void Init( CCNode* pParentNode );

		virtual void Deinit();

		virtual void Update( float dt );

		const JpVector2f& GetPosition() { return _vPosition; }
		void SetPosition( const JpVector2f& v ) { _vPosition = v; }

		void SetParentNode( CCNode* p ) { _pParentNode = p; }
		CCNode* GetParentNode() { return _pParentNode; }

		void SetLabelText( const char* pacText );

		const ccColor3B& GetTextColor() { return _TextColor; }
		void SetTextColor( const ccColor3B& Color );

	protected:

		//-----------------------
		// protected variables
		CCNode* _pParentNode;

		JpVector2f _vPosition;

		SoLabelBmFont* _pLabel;

		ccColor3B _TextColor;


		//-----------------------
		// protected functions
		SoLabelBmFont* CreateBmFontLabel( const std::string& sText, const std::string& sFontName, cocos2d::CCTextAlignment Alignment );
};




class SoWatermarkPreRelease : public SoWatermark
{
	public:

		//-----------------------
		// public functions

		SoWatermarkPreRelease() {};

		virtual ~SoWatermarkPreRelease() {};

		virtual void Init( CCNode* pParentNode );

		virtual void Deinit();

		virtual void Update( float dt );


	private:

		//-----------------------
		// private variables
};



class SoWatermarkBuildNumber : public SoWatermark
{
	public:

		//-----------------------
		// public functions

		SoWatermarkBuildNumber() {};

		virtual ~SoWatermarkBuildNumber() {};

		virtual void Init( CCNode* pParentNode );

		virtual void Deinit();

		virtual void Update( float dt );


	private:

		//-----------------------
		// private variables
};
