/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/



#pragma once

#include "stdafx.h"
#include "cocos2d.h"


#include "SoInputDispatcher.h"


#define SoWorkerParkingSpotList JpList< SoWorkerParkingSpot >


USING_NS_CC;


class SoWorkerParkingSpot
{
	public:
		//-----------------------
		// public enums:
		enum TYPE
		{
			TYPE_USABLE,
			TYPE_UNUSABLE,
			TYPE_LAST
		};

		//-----------------------
		// public functions

		SoWorkerParkingSpot();
		virtual ~SoWorkerParkingSpot();

		void Init( CCNode* pParentNode, TYPE eType );
		void Deinit();

		void Update( float dt );

		SoGameBitTile* GetGameBitTile() { return _pGameBitTile; }
		void SetGameBitTile( SoGameBitTile* p );

		JpVector2f GetPosition();

		bool IsClickedByUser() { return _bIsClickedByUser; }
		void SetIsClickedByUser( bool b ) { _bIsClickedByUser = b; }

		bool IsActivated() { return _bIsActivated; }
		void SetIsActivated( bool b ) { _bIsActivated = b; }

		bool OnInput( SoInputDispatcher::InputPacket* pInput );
		virtual bool IsPositionInside( const JpVector2f& vWorldPos );

		TYPE GetType() { return _eType; }

	private:

		//-----------------------
		// private variables

		SoSprite* _pSprite;
		CCNode* _pParentNode;

		float _fTimer;

		int _iTouchState;

		bool _bIsClickedByUser;

		bool _bIsActivated;

		SoGameBitTile* _pGameBitTile;

		TYPE _eType;

		//-----------------------
		// private functions
		bool IsPositionInsideSprite( const JpVector2f& vWorldPos, SoSprite* pSprite );
};




