/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#include "stdafx.h"

#include <stdio.h>


#include "JpUtils.h"
#include "NeConfig.h"
#include "NeCsvIn.h"
#include "NeTgaIo.h"
#include "SoActorManager.h"
#include "SoSaveSystem.h"
#include "SoUtils.h"
#include "TgScriptMain.h"

#include "mmgrChooser.h"





/******************************************************************************
 FUNCTION:  Init
******************************************************************************/
void TgScriptMain::Init()
{
	SoScript::Init();

	SetName( "Main" );

	_gFinalBoss = 0;

	//SoGameDungeon* pDungeon = SoGameDungeon::GetInstance();
	//hash hMasterRngSeed = pDungeon->GetMasterRngSeed();
	//hash hDerivedRngSeed = SoUtils::GenerateDerivedRngSeed( hMasterRngSeed, GetName().c_str() );
	//SetRngSeed( hDerivedRngSeed );

	_eCurrentState = STATE_WAIT_FOR_HERO_IN_LAST_STAGE_FIRST_TIME;
}



/******************************************************************************
 FUNCTION:  Deinit
******************************************************************************/
void TgScriptMain::Deinit()
{
}



/******************************************************************************
 FUNCTION:  Update
******************************************************************************/
void TgScriptMain::Update( float dt )
{
	//SoGameDungeon* pDungeon = SoGameDungeon::GetInstance();
	//SoTileMap* pMap = pDungeon->GetCurrentTileMap();
	//SoLevelTree* pLevelTree = pDungeon->GetLevelTree();
	//SoActorManager* pActorManager = SoActorManager::GetInstance();


	switch ( GetCurrentState() )
	{
		case STATE_WAIT_FOR_HERO_IN_LAST_STAGE_FIRST_TIME:
		{
			break;
		}

		case STATE_WAIT_FOR_HERO_IN_LAST_STAGE_AGAIN:
		{
			break;
		}

		case STATE_WAIT_FOR_HERO_TO_KILL_BOSS:
		{
			break;
		}

		case STATE_GAME_WON:
		{
			_pOwnerScriptManager->SetGameWon( true );
			break;
		}

		case STATE_LAST:
		default:
			ASSERTF( 0, ( "\nUnhandled script state." ) );
	}
}



/******************************************************************************
 FUNCTION:  SaveToFile
******************************************************************************/
void TgScriptMain::SaveToFile( SoSaveSystem* pSaveSystem )
{
	//-----------------------	
	// define the csv
	NeCsvOut* pCsvWriter = pSaveSystem->GetSharedCsvWriter();
	pCsvWriter->Clear();
	pCsvWriter->AddNewRow();
	pCsvWriter->AppendStringToLastRow( "Key" );
	pCsvWriter->AppendStringToLastRow( "Value" );


	//-----------------------	
	// save the parent class
	SoScript::SaveToFile( pSaveSystem );


	//-----------------------	
	// save this class
	pCsvWriter->AddNewRow();
	pCsvWriter->AppendStringToLastRow( "_eCurrentState" );
	pCsvWriter->AppendIntToLastRow( (int)_eCurrentState );
	
	pCsvWriter->AddNewRow();
	pCsvWriter->AppendStringToLastRow( "_gFinalBoss" );
	pCsvWriter->AppendUnsignedIntToLastRow( _gFinalBoss );

	pCsvWriter->WriteToFile( pSaveSystem->ConstructPathAndFileName( "TgScriptMain", GetScriptId() ) );
}



/******************************************************************************
 FUNCTION:  LoadFromFile
******************************************************************************/
void TgScriptMain::LoadFromFile( SoSaveSystem* pSaveSystem )
{
	//-----------------------	
	// load the csv
	NeCsvIn* pCsvReader = pSaveSystem->GetSharedCsvReader();
	pCsvReader->Clear();
	pCsvReader->ReadCsvFile( pSaveSystem->ConstructPathAndFileName( "TgScriptMain", GetScriptId() ) );
	pCsvReader->MakeHashIndicesFromRowValuesAtCol( 0 );


	//-----------------------
	// load the parent class data	
	SoScript::LoadFromFile( pSaveSystem );


	//-----------------------
	// load the data for this class
	_eCurrentState = (STATE)pCsvReader->GetHashByHashAndInt( 0xb0b0a013 /* "_eCurrentState" */, 1, (int)STATE_LAST );
	_gFinalBoss = pCsvReader->GetHashByHashAndInt( 0x47973520 /* "_gFinalBoss" */, 1, 0 );
}






