/*-----------------------------------------------------------------------------
 |  Copyright (c) 2011 Domowicz Creative Group, LLC    All Rights Reserved
 +----------------------------------------------------------------------------*/


#pragma once

#include "cocos2d.h"


// use this to disable unpresentable features before sending a build to a publisher
//#define IS_PUBLISHER_BUILD

#define FINAL_BUILD

#define WIN32_LEAN_AND_MEAN
#define NOMINMAX



/*
	This section is pretty much a copy/paste from CCPlatformConfig.h
	We copy it here because on iOS, CCPlatformConfig.h is not included,
	and so we need this copy to do platform checks.
	mdomowicz 2012_08_11
*/

// define supported target platform macro which CC uses.
#define DCG_PLATFORM_UNKNOWN            0
#define DCG_PLATFORM_IOS                1
#define DCG_PLATFORM_ANDROID            2
#define DCG_PLATFORM_WIN32              3
#define DCG_PLATFORM_MARMALADE          4
#define DCG_PLATFORM_LINUX              5
#define DCG_PLATFORM_BADA               6
#define DCG_PLATFORM_QNX                   7

// Determine target platform by compile environment macro.
#define DCG_TARGET_PLATFORM             DCG_PLATFORM_UNKNOWN

// iphone
#if ! DCG_TARGET_PLATFORM && (defined(TARGET_OS_IPHONE) || defined(TARGET_IPHONE_SIMULATOR))
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_IOS
	#define DCG_SUPPORT_PVRTC
#endif

// android
#if ! DCG_TARGET_PLATFORM && defined(ANDROID)
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_ANDROID
#endif

// win32
#if ! DCG_TARGET_PLATFORM && (defined(WIN32) && defined(_WINDOWS))
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_WIN32
#endif

// linux
#if ! DCG_TARGET_PLATFORM && defined(LINUX)
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_LINUX
#endif

// marmalade
#if ! DCG_TARGET_PLATFORM && defined(MARMALADE)
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_MARMALADE
#endif

// bada
#if ! DCG_TARGET_PLATFORM && defined(SHP)
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM         DCG_PLATFORM_BADA
#endif

// qnx
#if ! DCG_TARGET_PLATFORM && defined(__QNX__)
	#undef  DCG_TARGET_PLATFORM
	#define DCG_TARGET_PLATFORM     DCG_PLATFORM_QNX
#endif


#define DCG_IS_TARGET_WIN32 (DCG_TARGET_PLATFORM == DCG_PLATFORM_WIN32)
#define DCG_IS_TARGET_IOS (DCG_TARGET_PLATFORM == DCG_PLATFORM_IOS)
#define DCG_IS_TARGET_ANDROID (DCG_TARGET_PLATFORM == DCG_PLATFORM_ANDROID)
#define DCG_IS_TARGET_LINUX (DCG_TARGET_PLATFORM == DCG_PLATFORM_LINUX)
#define DCG_IS_TARGET_OSX (0)


#if DCG_IS_TARGET_WIN32
	#pragma warning (disable:4996)  // disables: 'function': was declared deprecated
#endif

#if DCG_IS_TARGET_IOS
	// disables: 'function': was declared deprecated
	#pragma GCC diagnostic ignored "-Wdeprecated-declarations"  

	// disables: Conversion from string literal to char* is depricated
	#pragma GCC diagnostic ignored "-Wwrite-strings" 
#endif
