<?php


/******************************************************************************
 FUNCTION:  SqlConnect
******************************************************************************/
function SqlConnect( $sHostName, $sUserLogin, $sPassword, $sDatabaseName )
{
	$db = new mysqli( $sHostName, $sUserLogin, $sPassword, $sDatabaseName );

	if ( !$db )
	{
		echo "Error: Could not connect to database";
		exit;
	}

	return $db;
}



/******************************************************************************
 FUNCTION:  SqlQuery
******************************************************************************/
function SqlQuery
( 
	$db, 
	$sQuery 
)
{
	$oResult = $db->query( $sQuery );

	// $oResult will be false on error.
	// However it can be either true or an mysqli_result object on success.
	// See documentation on query() here: 
	// http://www.php.net/manual/en/mysqli.query.php
	if ( $oResult == false )
	{
		echo $sQuery . "<br>" . "sql query failed!";
		exit;
	}

	return $oResult;
}



/******************************************************************************
 FUNCTION:  SqlClose
******************************************************************************/
function SqlClose( $db )
{
	$db->close();
}



/******************************************************************************
 FUNCTION:  SqlDoesTableExist
******************************************************************************/
function SqlDoesTableExist( $db, $sTableName )
{
	$oResult = SqlQuery( $db, "SHOW TABLES LIKE '".$sTableName."'" );
	$iNumRows = mysqli_num_rows( $oResult );
	$oResult->free();
	return ( $iNumRows > 0 );
}



/******************************************************************************
 FUNCTION:  SqlDropTable
******************************************************************************/
function SqlDropTable( $db, $sTableName )
{
	$oResult = SqlQuery( $db, "DROP TABLE IF EXISTS " . $sTableName );

	if ( $oResult != false && $oResult != true )
		$oResult->free();
}







