# set params

# !!!!!!!!!! IT IS HIGHLY UNLIKELY THAT YOU HAVE THE CORRECT PATH
# !!!!!!!!!! SETTINGS BELOW.  COPY THIS FILE TO _DcgBuildLocal.sh
# !!!!!!!!!! AND CHANGE THE SETTINGS TO FIT YOUR ENVIRONMENT.

#NDK_ROOT_LOCAL=/cygdrive/e/android/android-ndk-r8
#COCOS2DX_ROOT_LOCAL=/cygdrive/f/Project/dumganhar/cocos2d-x
#NDK_ROOT_LOCAL=/home/j/dev/android-ndk-r8b
#COCOS2DX_ROOT_LOCAL=/home/j/dev/dcg/startercocos/startercocos/cocos2d-x
NDK_ROOT_LOCAL=/cygdrive/d/dev/Android/android-ndk-r9
COCOS2DX_ROOT_LOCAL=/cygdrive/d/dev/Dcg/ManhattanC/ManhattanC_Android/cocos2d-x


buildexternalsfromsource=

usage(){
cat << EOF
usage: $0 [options]

Build C/C++ native code using Android NDK

OPTIONS:
-s	Build externals from source
-h	this help
EOF
}

while getopts "s" OPTION; do
case "$OPTION" in
s)
buildexternalsfromsource=1
;;
h)
usage
exit 0
;;
esac
done

# try to get global variable
if [ $NDK_ROOT"aaa" != "aaa" ]; then
echo "use global definition of NDK_ROOT: $NDK_ROOT"
NDK_ROOT_LOCAL=$NDK_ROOT
fi

if [ $COCOS2DX_ROOT"aaa" != "aaa" ]; then
echo "use global definition of COCOS2DX_ROOT: $COCOS2DX_ROOT"
COCOS2DX_ROOT_LOCAL=$COCOS2DX_ROOT
fi

HELLOWORLD_ROOT=$COCOS2DX_ROOT_LOCAL/HelloWorld/proj.android


# On Windows 7, under Cygwin, some of the generated files placed in
# /obj are given 000 permissions.  This ends up breaking the build
# because some of the files are not readable.  So here, I'm 
# manually setting the readable permission on all files in /obj
# mdomowicz 2013_11_01
if [ -d $HELLOWORLD_ROOT/obj ]; then
chmod a+r obj -R
fi


# When using cp to copy files from /Resources to /assets, the .svn
# folders get copied too.  We don't want the .svn folders in the
# android build.  But also, for some unknown reason, on my windows 7
# machine, the newly created .svn folders acquire special permissions
# and cannot be deleted without admin access, making them a total
# pain to remove.  So, that's why I've commented out the /assets
# creation here.  Use the DcgCopyAssets.bat instead to copy the
# the assets.  mdomowicz 2013_10_31
#------------------------------------------------
# make sure assets is exist
#if [ -d $HELLOWORLD_ROOT/assets ]; then
#rm -rf $HELLOWORLD_ROOT/assets
#fi

#mkdir $HELLOWORLD_ROOT/assets

# copy resources
#for file in $COCOS2DX_ROOT_LOCAL/HelloWorld/Resources/*
#do
#if [ -d $file ]; then
#cp -rf $file $HELLOWORLD_ROOT/assets
#fi

#if [ -f $file ]; then
#cp $file $HELLOWORLD_ROOT/assets
#fi
#done
#------------------------------------------------


if [[ $buildexternalsfromsource ]]; then
echo "Building external dependencies from source"
$NDK_ROOT_LOCAL/ndk-build -C $HELLOWORLD_ROOT $* \
NDK_MODULE_PATH=${COCOS2DX_ROOT_LOCAL}:${COCOS2DX_ROOT_LOCAL}/cocos2dx/platform/third_party/android/source
else
echo "Using prebuilt externals"
$NDK_ROOT_LOCAL/ndk-build -C $HELLOWORLD_ROOT $* \
NDK_MODULE_PATH=${COCOS2DX_ROOT_LOCAL}:${COCOS2DX_ROOT_LOCAL}/cocos2dx/platform/third_party/android/prebuilt
fi
