#include "stdafx.h"
#include "main.h"
#include "../Classes/AppDelegate.h"
#include "../Classes/SoConfigManager.h"
#include "../Classes/SoUtils.h"
#include "CCEGLView.h"
#include "JpUtils.h"
#include "Resource.h"

USING_NS_CC;

int APIENTRY _tWinMain(HINSTANCE hInstance,
                       HINSTANCE hPrevInstance,
                       LPTSTR    lpCmdLine,
                       int       nCmdShow)
{
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

	SoConfigManager::CreateInstance();
	SoConfigManager::GetInstance()->Init();

	int iResolutionX = 480;
	int iResolutionY = 320;

	NeConfig::Line* pLine = SoConfigManager::GetInstance()->FindLine( "iResolution" );
	if ( pLine )
	{
		iResolutionX = pLine->GetInt( 1 );
		iResolutionY = pLine->GetInt( 2 );
	}

    // create the application instance
    AppDelegate app;
    CCEGLView& eglView = CCEGLView::sharedOpenGLView();

	JpVector2i vMaxRes = JpUtils::GetMaxWindowedResolution();

	iResolutionX = Clamp( iResolutionX, 480, vMaxRes.X );
	iResolutionY = Clamp( iResolutionY, 320, vMaxRes.Y );
	
	// We want the resolution to be divisible by 2 and 4, in order to successfully
	// find the center and quarter points of the screen using integer division.
	while ( iResolutionX % 4 != 0 )
		iResolutionX --;
	while ( iResolutionY % 4 != 0 )
		iResolutionY --;

	eglView.setViewName("Achoir");
	eglView.setFrameSize( iResolutionX, iResolutionY );

	HWND hWnd = eglView.getHWnd();

	SetClassLong ( hWnd, GCL_HICON, (long)LoadIcon( hInstance, MAKEINTRESOURCE ( IDI_ICON_DUNGEONX ) ) );

	// set the design resolution screen size, if you want to use Design Resoulution scaled to current screen, please uncomment next line.
    // eglView.setDesignResolutionSize(480, 320);

	int iProgramResults = CCApplication::sharedApplication().run();
	SoConfigManager::DeleteInstance();

    return iProgramResults;
}


